-- MegaLettering translated comics PHP engine
-- Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>
--
-- Permission to use, copy, modify, and/or distribute this software for any
-- purpose with or without fee is hereby granted, provided that the above
-- copyright notice and this permission notice appear in all copies.
-- 
-- THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
-- WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
-- MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
-- ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
-- WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
-- ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
-- OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

-- phpMyAdmin SQL Dump
-- version 3.0.0
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Oct 26, 2008 at 07:26 PM
-- Server version: 5.0.67
-- PHP Version: 5.2.6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `MTi`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Baloons`
--

DROP TABLE IF EXISTS `MTi_Baloons`;
CREATE TABLE `MTi_Baloons` (
  `IDBaloon` int(11) unsigned NOT NULL auto_increment,
  `IDStrip` smallint(6) unsigned NOT NULL default '0',
  `Location` smallint(5) unsigned NOT NULL default '0' COMMENT 'frame number * 100 + baloon number',
  `Shape` text character set ascii NOT NULL,
  `IDCharacter` int(11) default NULL,
  `ColorBG` mediumint(8) unsigned NOT NULL default '16777215',
  `ColorFG` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`IDBaloon`),
  KEY `IDStrip` (`IDStrip`),
  KEY `Location` (`Location`),
  KEY `IDCharacter` (`IDCharacter`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Baloons shape';

--
-- RELATIONS FOR TABLE `MTi_Baloons`:
--   `IDCharacter`
--       `MTi_Characters` -> `IDCharacter`
--   `IDStrip`
--       `MTi_Strips` -> `IDStrip`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Characters`
--

DROP TABLE IF EXISTS `MTi_Characters`;
CREATE TABLE `MTi_Characters` (
  `IDCharacter` smallint(5) unsigned NOT NULL auto_increment,
  `Name` varchar(50) NOT NULL default '',
  `Thread` tinyint(4) unsigned NOT NULL default '1',
  PRIMARY KEY  (`IDCharacter`),
  UNIQUE KEY `Name` (`Name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Character names';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Compress`
--

DROP TABLE IF EXISTS `MTi_Compress`;
CREATE TABLE `MTi_Compress` (
  `Key` varbinary(16) NOT NULL default '                ',
  `MD5` varbinary(16) NOT NULL default '                ',
  `Value` varchar(255) character set ascii collate ascii_bin NOT NULL,
  PRIMARY KEY  (`Key`),
  KEY `MD5` (`MD5`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Utility table, to compress varchar fields.';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Console`
--

DROP TABLE IF EXISTS `MTi_Console`;
CREATE TABLE `MTi_Console` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDStrip` smallint(6) unsigned NOT NULL default '0',
  `Position` enum('left','right') character set ascii NOT NULL default 'left',
  `Username` varchar(15) character set ascii NOT NULL,
  `Image` varchar(50) character set ascii collate ascii_bin NOT NULL,
  `ImageLink` tinytext NOT NULL,
  `ImageAlt` varchar(50) NOT NULL,
  `Title` tinytext NOT NULL,
  `Content` text NOT NULL,
  PRIMARY KEY  (`IDLanguage`,`Position`,`IDStrip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Console rants (language dependant)';

--
-- RELATIONS FOR TABLE `MTi_Console`:
--   `IDLanguage`
--       `MTi_Languages` -> `IDLanguage`
--   `IDStrip`
--       `MTi_Strips` -> `IDStrip`
--   `Username`
--       `MTi_Staff` -> `Username`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Languages`
--

DROP TABLE IF EXISTS `MTi_Languages`;
CREATE TABLE `MTi_Languages` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `Name` varchar(50) NOT NULL,
  `Code` varchar(20) character set ascii NOT NULL,
  `Active` tinyint(1) NOT NULL default '0',
  `URL` tinytext character set ascii collate ascii_bin NOT NULL,
  `Default_Style` varchar(25) character set ascii NOT NULL default 'normal',
  `Default_RTL` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`IDLanguage`),
  UNIQUE KEY `Nome` (`Name`),
  KEY `Active` (`Active`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Available languages';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Links`
--

DROP TABLE IF EXISTS `MTi_Links`;
CREATE TABLE `MTi_Links` (
  `IDLink` int(11) unsigned NOT NULL auto_increment,
  `IDLanguage` char(2) character set ascii NOT NULL,
  `Publish` date NOT NULL default '0000-00-00',
  `URL` tinytext character set ascii collate ascii_bin NOT NULL,
  `Active` tinyint(4) unsigned NOT NULL default '1',
  `Title` varchar(50) NOT NULL,
  `Type` varchar(25) NOT NULL,
  `Description` text NOT NULL,
  PRIMARY KEY  (`IDLink`),
  KEY `WebOrder` (`IDLanguage`,`Publish`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Link to related/interesting websites';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Lock`
--

DROP TABLE IF EXISTS `MTi_Lock`;
CREATE TABLE `MTi_Lock` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDStrip` smallint(6) unsigned NOT NULL default '0',
  `Username` varchar(15) character set ascii NOT NULL,
  `Since` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`IDLanguage`,`IDStrip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Used for editor locking, to avoid mutual editing.';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Polls`
--

DROP TABLE IF EXISTS `MTi_Polls`;
CREATE TABLE `MTi_Polls` (
  `IDPoll` smallint(5) unsigned NOT NULL default '0',
  `IDLanguage` char(2) character set ascii NOT NULL,
  `Name` tinytext NOT NULL,
  `Text` text NOT NULL,
  `DateStart` date NOT NULL default '2004-01-01',
  `DateEnd` date NOT NULL default '2030-01-01',
  PRIMARY KEY  (`IDPoll`),
  KEY `Generic` (`IDLanguage`,`DateStart`,`DateEnd`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Polls generic data';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Polls_Values`
--

DROP TABLE IF EXISTS `MTi_Polls_Values`;
CREATE TABLE `MTi_Polls_Values` (
  `IDPoll` smallint(5) unsigned NOT NULL default '0',
  `Value` tinyint(3) unsigned NOT NULL default '0',
  `Name` tinytext NOT NULL,
  PRIMARY KEY  (`IDPoll`,`Value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Single values for each poll';

--
-- RELATIONS FOR TABLE `MTi_Polls_Values`:
--   `IDPoll`
--       `MTi_Polls` -> `IDPoll`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Polls_Votes`
--

DROP TABLE IF EXISTS `MTi_Polls_Votes`;
CREATE TABLE `MTi_Polls_Votes` (
  `IDPoll` smallint(5) unsigned NOT NULL default '0',
  `SID` int(10) unsigned NOT NULL default '0',
  `Value` tinyint(3) unsigned NOT NULL default '0',
  `Date` datetime NOT NULL default '0000-00-00 00:00:00',
  `IP` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`IDPoll`,`SID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Single votes for each poll';

--
-- RELATIONS FOR TABLE `MTi_Polls_Votes`:
--   `SID`
--       `MTi_Sessions` -> `SID`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Sessions`
--

DROP TABLE IF EXISTS `MTi_Sessions`;
CREATE TABLE `MTi_Sessions` (
  `SID` int(10) unsigned NOT NULL auto_increment,
  `Value` text character set ascii collate ascii_bin NOT NULL,
  `FirstDate` date NOT NULL default '0000-00-00',
  `LastDate` date NOT NULL default '0000-00-00',
  `LastIP` varchar(255) character set ascii NOT NULL,
  `Count` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`SID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Staff`
--

DROP TABLE IF EXISTS `MTi_Staff`;
CREATE TABLE `MTi_Staff` (
  `Username` varchar(15) NOT NULL default '',
  `Name` varchar(50) NOT NULL,
  `IDLanguage` char(2) character set ascii NOT NULL,
  `email` varchar(50) NOT NULL default '',
  `Role` varchar(50) NOT NULL,
  PRIMARY KEY  (`Username`),
  KEY `IDLingua` (`IDLanguage`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Staff & roles (language dependant)';

--
-- RELATIONS FOR TABLE `MTi_Staff`:
--   `IDLanguage`
--       `MTi_Languages` -> `IDLanguage`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Stats`
--

DROP TABLE IF EXISTS `MTi_Stats`;
CREATE TABLE `MTi_Stats` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDStrip` int(10) unsigned NOT NULL default '0',
  `Date` date NOT NULL default '0000-00-00',
  `Count` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`IDLanguage`,`IDStrip`,`Date`),
  KEY `Date` (`Date`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Strips`
--

DROP TABLE IF EXISTS `MTi_Strips`;
CREATE TABLE `MTi_Strips` (
  `IDStrip` smallint(6) unsigned NOT NULL default '0',
  `URL` tinytext character set ascii collate ascii_bin NOT NULL,
  `DimX` smallint(6) unsigned NOT NULL default '0',
  `DimY` smallint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`IDStrip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Strip data';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Styles`
--

DROP TABLE IF EXISTS `MTi_Styles`;
CREATE TABLE `MTi_Styles` (
  `Name` varchar(25) character set ascii NOT NULL,
  `Font` varchar(50) character set ascii NOT NULL,
  `Size` float(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`Name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Text styles';

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Texts`
--

DROP TABLE IF EXISTS `MTi_Texts`;
CREATE TABLE `MTi_Texts` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDBaloon` int(11) unsigned NOT NULL default '0',
  `CenterX` smallint(6) NOT NULL default '0',
  `CenterY` smallint(6) NOT NULL default '0',
  `Content` text NOT NULL,
  `Translator` varchar(15) character set ascii NOT NULL,
  PRIMARY KEY  (`IDLanguage`,`IDBaloon`),
  FULLTEXT KEY `Content` (`Content`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Baloon texts (language dependant)';

--
-- RELATIONS FOR TABLE `MTi_Texts`:
--   `IDBaloon`
--       `MTi_Baloons` -> `IDBaloon`
--   `IDLanguage`
--       `MTi_Languages` -> `IDLanguage`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Texts_Notes`
--

DROP TABLE IF EXISTS `MTi_Texts_Notes`;
CREATE TABLE `MTi_Texts_Notes` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDBaloon` int(10) unsigned NOT NULL,
  `Translator` varchar(15) character set ascii NOT NULL,
  `Vote` tinyint(4) NOT NULL default '0',
  `Note` text,
  PRIMARY KEY  (`IDLanguage`,`IDBaloon`,`Translator`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MTi_ThreadElements`
--

DROP TABLE IF EXISTS `MTi_ThreadElements`;
CREATE TABLE `MTi_ThreadElements` (
  `IDStrip` smallint(5) unsigned NOT NULL default '0',
  `IDThread` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`IDStrip`,`IDThread`),
  KEY `IDThread` (`IDThread`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- RELATIONS FOR TABLE `MTi_ThreadElements`:
--   `IDStrip`
--       `MTi_Strips` -> `IDStrip`
--   `IDThread`
--       `MTi_Threads` -> `IDThread`
--

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Threads`
--

DROP TABLE IF EXISTS `MTi_Threads`;
CREATE TABLE `MTi_Threads` (
  `IDThread` smallint(5) unsigned NOT NULL auto_increment,
  `Name` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`IDThread`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MTi_Titles`
--

DROP TABLE IF EXISTS `MTi_Titles`;
CREATE TABLE `MTi_Titles` (
  `IDLanguage` char(2) character set ascii NOT NULL,
  `IDStrip` int(11) unsigned NOT NULL default '0',
  `Content` tinytext NOT NULL,
  `Publish` date NOT NULL default '0000-00-00',
  `Version` datetime NOT NULL default '0000-00-00 00:00:00',
  `Discussione` tinytext character set ascii collate ascii_bin NOT NULL,
  PRIMARY KEY  (`IDLanguage`,`IDStrip`),
  KEY `Publishing` (`Publish`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='Strip titles and publish date (language dependant)';

--
-- RELATIONS FOR TABLE `MTi_Titles`:
--   `IDLanguage`
--       `MTi_Languages` -> `IDLanguage`
--   `IDStrip`
--       `MTi_Strips` -> `IDStrip`
--
