﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

// This page contains much repeated content
ini_set('zlib.output_compression', TRUE);

// This page shouldn't be cached at all <http://it.php.net/manual/en/function.header.php>
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

chdir('..');
require_once('image.inc.php');
if ($config['Local']) {
    require_once('safe_envelope.inc.php');
    require_once('transfer.inc.php');
}

$id = 0;
if (isset($_GET['id']) && is_numeric($_GET['id']))
    $id = (int)$_GET['id'];
$bal = 0;
if (isset($_GET['bal']) && is_numeric($_GET['bal']))
    $bal = (int)$_GET['bal'];
$parms = '';
$debug = 0;
if (isset($_GET['debug']) && is_numeric($_GET['debug']))
    $debug = (int)$_GET['debug'];
if ($debug)
    $parms .= '&amp;debug=1';
$baloonedit = 0;
if (isset($_GET['baloonedit']) && is_numeric($_GET['baloonedit']))
    $baloonedit = (int)$_GET['baloonedit'];
if ($baloonedit)
    $parms .= '&amp;baloonedit=1';
$username = isset($_SERVER['REMOTE_USER']) ? $_SERVER['REMOTE_USER'] : '';
if (strlen($username) < 1)
    $username = 'anonymous';

// manage language
require_once('gettext.inc.php');

$errors = '';

if (isset($_POST['type'])) { // it's a DB related action
    $locked = myquery1("SELECT Username FROM ${dbprefix}_Lock WHERE IDLanguage = ? AND IDStrip = ?;", array($lang, $id));
    if ($locked !== FALSE)
	$locked = (strlen($locked) > 0) && ($locked != $username);
    if (($lang == 'en')) // this and next operaitons are not doable on english strips
	$errors .= _('English strips are not updatable.') . "\n";
    elseif ($_POST['type'] == 'locking') {
	if (isset($_POST['lock']))
	    myupdate("REPLACE INTO ${dbprefix}_Lock (IDLanguage, IDStrip, Username, Since)
		VALUES (?, ?, ?, NOW());",
		array($lang, $id, $username));
	elseif (isset($_POST['unlock']))
	    myupdate("DELETE FROM ${dbprefix}_Lock WHERE IDLanguage = ? AND IDStrip = ?;", array($lang, $id));
    } elseif ($locked && (($_POST['type'] == 'title') || ($_POST['type'] == 'baloon')))
	$errors .= _('Strip is locked.') . "\n";
    elseif ($_POST['type'] == 'title') {
	$id = (int)$_POST['idstrip'];
	if (isset($_POST['insert'])) {
	    $data = mydate($_POST['publish']);
	    if (myquery1("SELECT IDStrip FROM ${dbprefix}_Strips WHERE IDStrip = ?;", array($id)) === FALSE)
		$errors .= _('IDStrip must be existing.') . "\n";
	    elseif (myquery1("SELECT IDStrip FROM ${dbprefix}_Titles WHERE IDLanguage = ? AND IDStrip = ? AND Publish = ?;", array($lang, $id, $data))) {
		// ID e data sono uguali, aggiorno Title e Discussione
		myupdate("UPDATE ${dbprefix}_Titles SET Content = ?, Discussione = ?
		    WHERE IDLanguage = ? AND IDStrip = ?;",
		    array($_POST['text'], $_POST['discussione'], $lang, $id));
	    } else {
		$date_ok = TRUE;
		if (!isset($_POST['publish_ok']) || ($_POST['publish_ok'] != '1')) {
		    if (myqueryR("SELECT IDStrip FROM ${dbprefix}_Titles WHERE IDLanguage = ? AND IDStrip <> ? AND Publish >= ?;", array($lang, $id, $data)))
			$date_ok = FALSE;
		}
		if ($date_ok) {
		    myupdate("REPLACE INTO ${dbprefix}_Titles (IDLanguage, IDStrip, Content, Publish, Discussione) VALUES (?, ?, ?, ?, ?);",
			array($lang, $id, $_POST['text'], $data, $_POST['discussione']));
		} else
		    $errors .= sprintf(_('The date you inserted is previous to the date of a different existing strip (e.g. strip %1$d).'), $row[0]) . "\n";
	    }
	} elseif (!$config['Local']) {
	    // do nothing else: the following options are used only by Local mode
	} elseif (isset($_POST['fetch'])) {
	    $data = @file_get_contents($config['Server'] . "export.php?lang=$lang&id=$id");
	    if (!$data)
		$errors .= _('Cannot fetch data, are you online?') . "\n";
	    elseif ($arr = safe_decode($data)) {
		$ver = myquery1("SELECT Version FROM ${dbprefix}_Titles WHERE IDLanguage = ? AND IDStrip = ?;", array($lang, $id));
		if (!(isset($_POST['publish_ok']) && ($_POST['publish_ok'] == '1')) && ($ver !== false) && ($arr['Version'] < $ver))
		    $errors .= _('Fetched data is older than data we have here.') . "\n";
		elseif ($arr['IDLanguage'] != $lang)
		    $errors .= _('Fetched data refers to a different IDLanguage.') . "\n";
		elseif ($arr['IDStrip'] != $id)
		    $errors .= _('Fetched data refers to a different IDStrip.') . "\n";
		else {
		    strip_import($arr);
		    DeleteStrip($id, $lang); // delete strip from disk, so it is re-generated at next request
		}
	    } else
		$errors .= _('Fetched data was invalid.') . "\n";
	} elseif (isset($_POST['send'])) {
	    //TODO implement it
	}
    } elseif ($_POST['type'] == 'baloon') {
	if ($baloonedit && isset($_POST['insert']) && ($_POST['insert'] == 'Insert')) {
	    $location = (((int)$_POST['order1']) * 100 + ((int)$_POST['order2']));
	    $shape = $_POST['coords'];
	    $do_insert = true;
	    if (myquery1("SELECT IDBaloon FROM ${dbprefix}_Baloons WHERE IDStrip = ? AND Location = ?;", array($id, $location))) {
		$errors .= sprintf(_('There is already a baloon with location (%d, %d): duplicate not inserted.'), (int)$_POST['order1'], (int)$_POST['order2']) . "\n";
		$do_insert = false;
	    }
	    if (myquery1("SELECT IDBaloon FROM ${dbprefix}_Baloons WHERE IDStrip = ? AND Shape = ?;", array($id, $shape))) {
		$errors .= sprintf(_('There is already a baloon with shape \'%s\': duplicate not inserted.'), $_POST['coords']) . "\n";
		$do_insert = false;
	    }
	    if ($do_insert) {
		// no duplicates detected, let's insert it
		myupdate("INSERT INTO ${dbprefix}_Baloons (IDStrip, Location, Shape, IDCharacter, ColorBG, ColorFG) VALUES (?, ?, ?, ?, ?, ?);",
		    array($id, $location, $shape, (int)$_POST['idcharacter'], hexdec($_POST['colorBG']), hexdec($_POST['colorFG'])));
		$bal = $db->lastInsertId();
		myupdate("INSERT INTO ${dbprefix}_Texts (IDLanguage, IDBaloon, CenterX, CenterY, Content, Translator) VALUES (?, ?, ?, ?, ?, ?);",
		    array($lang, $bal, (int)$_POST['centerX'], (int)$_POST['centerY'], $_POST['text'], $username));
	    }
	} elseif (isset($_POST['update']) && ($_POST['update'] == 'Update')) {
	    if ($baloonedit)
		myupdate("REPLACE INTO ${dbprefix}_Baloons (IDBaloon, IDStrip, Location, Shape, IDCharacter, ColorBG, ColorFG) VALUES (?, ?, ?, ?, ?, ?, ?);",
		    array((int)$_POST['idbaloon'], $id, (((int)$_POST['order1']) * 100 + ((int)$_POST['order2'])),
			$_POST['coords'], (int)$_POST['idcharacter'], hexdec($_POST['colorBG']), hexdec($_POST['colorFG'])));
	    if (strlen($_POST['text']) > 0)
		myupdate("REPLACE INTO ${dbprefix}_Texts (IDLanguage, IDBaloon, CenterX, CenterY, Content, Translator) VALUES (?, ?, ?, ?, ?, ?);",
		    array($lang, (int)$_POST['idbaloon'], (int)$_POST['centerX'], (int)$_POST['centerY'], $_POST['text'], $username));
	    else
		myupdate("DELETE FROM ${dbprefix}_Texts WHERE IDLanguage = ? AND IDBaloon = ?;",
		    array($lang, (int)$_POST['idbaloon']));
	    if (((int)$_POST['vote'] != 0) || (strlen($_POST['note']) > 0))
		myupdate("REPLACE INTO ${dbprefix}_Texts_Notes (IDLanguage, IDBaloon, Translator, Vote, Note) VALUES (?, ?, ?, ?, ?);",
		    array($lang, (int)$_POST['idbaloon'], $username, (int)$_POST['vote'], $_POST['note']));
	} elseif ($baloonedit && isset($_POST['delete']) && $_POST['delete'] == 'Delete') {
	    myupdate("DELETE FROM ${dbprefix}_Baloons WHERE IDBaloon = ?;", array((int)$_POST['idbaloon']));
	    myupdate("DELETE FROM ${dbprefix}_Texts WHERE IDLanguage = ? AND IDBaloon = ?;",
		array($lang, (int)$_POST['idbaloon']));
	    if ($bal == $_POST['idbaloon'])
		$bal = 0;
	}
	myupdate("UPDATE ${dbprefix}_Titles SET Version = NOW() WHERE IDLanguage = ? AND IDStrip = ?;",
	    array($lang, $id));
	DeleteStrip($id, $lang); // delete strip from disk, so it is re-generated at user request
    } elseif ($_POST['type'] == 'console') {
	$tidy_config = array(
	    'ascii-chars' => 0,
	    'indent' => 1,
	    'language' => 'it',
	    'newline' => 'LF',
	    'output-bom' => 0,
	    'output-xhtml' => 1,
	    'quote-ampersand' => 1,
	    'quote-marks' => 0,
	    'quote-nbsp' => 0,
	    'show-body-only' => 1,
	    'wrap' => 0,
	);
	$tidy_context_pre = '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><body>';
	$tidy_context_post = '</body></html>';
	$txt = $_POST['text'];
	// add BRs only if there is no BR already
	if (!preg_match('/<\s*br\s*\/?>/i', $txt))
	    $txt = preg_replace('/\r?\n/', "<br/>\n", $txt);
	// tidy up the code, so that it is valid nonetheless (and user can modify it, if it changes too much)
	$txt = tidy_repair_string($tidy_context_pre . $txt . $tidy_context_post, $tidy_config, 'UTF8' /* TIDY wants it without '-' */);
	myupdate("REPLACE INTO ${dbprefix}_Console (IDLanguage, IDStrip, Position, Username, Image, ImageLink, ImageAlt, Title, Content) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?);",
	    array($lang, $id, $_POST['position'], $_POST['username'], $_POST['image'],
		$_POST['imm_link'], $_POST['imm_alt'], $_POST['title'], $txt));
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
    <title>MegaLettering editor - <?=GetStripTitle($id, $lang)?></title>
    <link rel="stylesheet" href="/MTi.css" type="text/css"/>
    <link rel="shortcut icon" href="/image/favicon.ico" type="image/x-icon"/>
    <script src="dom-drag.js" type="text/javascript"></script>
    <script src="editor.js" type="text/javascript"></script>
</head>

<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#EB5252" vlink="#ECECA3">

<h1><b><tt>MegaLettering EDITOR</tt></b></h1>

<table>
    <tr>
	<td>Editor:</td>
	<td><a href="editor.php?lang=<?=$lang?>&amp;id=<?=$id?>">[main]</a></td>
	<td><a href="editor_characters.php?lang=<?=$lang?>">[characters]</a></td>
	<td><a href="editor_style.php?lang=<?=$lang?>">[styles]</a></td>
	<td><!--a href="editor_links.php?lang=<?=$lang?>"-->[links]<!--/a--></td>
    </tr>
</table>

<?
// Loade the strip (created on-the-fly if not up-to-date)
ob_start();
$strip = GetStrip($id, 'xx');
if (!$strip)
    echo "GetStrip returned FALSE.\n";
$us = array_keys($style_cache, FALSE);
if (sizeof($us) > 0) {
    echo _('Unknown styles:');
    foreach($us as $s)
	echo " $s";
    echo "\n";
}
$errors .= ob_get_contents();
ob_end_clean();
if ($errors)
    echo "<pre><font color='red'>$errors</font></pre>";
?>

<table id="editor_container"><tr><td>
<div id="baloons">
    <img id="strip" src="<?=$baloonedit ? "editor_nocache.php?lang=$lang&amp;id=$id" : "../$strip[filename]"?>" style="width: <?=$strip['width']?>px; height: <?=$strip['height']?>px; border: none;"/>
<?
// search current baloon
$bal_cx = '0';
$bal_cy = '0';
$bal_loc_1 = 0;
$bal_loc_2 = 0;
$bal_shp = 'p';
$bal_chr = 0;
$col_bg = 'FFFFFF';
$col_fg = '000000';
$q = $db->prepare("SELECT IDBaloon, IDStrip, Location, Shape, IDCharacter, ColorBG, ColorFG FROM ${dbprefix}_Baloons WHERE IDBaloon = ?;");
$q->execute(array($bal));
if ($row = $q->fetch(PDO::FETCH_ASSOC)) {
    $bal_loc_1 = (int)((int)$row['Location'] / 100);
    $bal_loc_2 = (int)((int)$row['Location'] % 100);
    $bal_shp = (string)$row['Shape'];
    $bal_chr = (int)$row['IDCharacter'];
    $col_bg = sprintf('%06X', $row['ColorBG']);
    $col_fg = sprintf('%06X', $row['ColorFG']);
}
// print baloons
$style_default = myquery1("SELECT Default_Style FROM ${dbprefix}_Languages WHERE IDLanguage = ?;", array($lang));
if ($style_default === FALSE)
    $style_default = 'normal';
$align_default = 'center';
$baloons = GetStripBaloons($id, $lang);
foreach ($baloons as $row) {
    if (!strlen($row['Content'])) // skip empty baloons
	continue;
    $idbaloon = (int)$row['IDBaloon'];
    $color = sprintf('%06X', $row['ColorFG']);
    $loc_1 = (int)((int)$row['Location'] / 100);
    $loc_2 = (int)((int)$row['Location'] % 100);
    $centerX = (int)$row['CenterX'];
    $centerY = (int)$row['CenterY'];
    $text = htmlspecialchars(urlencode($row['Content']));
    // calculate size and position
    $align = $align_default;
    $text_style = MyImageTTFBBox_Baloon(split("\r?\n", $row['Content']), $style_default, $align);
    $sizeX = $sizeY = 0;
    foreach ($text_style as $line) {
	$sizeX = max($sizeX, $line['bbox']['width']);
	$sizeY += $line['bbox']['height'];
    }
    switch($align) {
    case 'left':
	$offX = 0;
	break;
    case 'center':
	$offX = (int)($sizeX / 2);
	break;
    case 'right':
	$offX = $sizeX;
	break;
    default:
	die("unexpected alignment: [$align]"); //TODO
    }
    $offY = (int)($sizeY / 2);
    $offX += 2; $offY += 2; // account for 2px of border
    $posX = $centerX - $offX;
    $posY = $centerY - $offY;
    $img = "<img id='bal" . (($idbaloon == $bal) ? 0 : $numBaloon) . "' class='baloon' " .
	"style='left: ${posX}px; top: ${posY}px; width: ${sizeX}px; height: ${sizeY}px;' " .
	"dragx='$offX' dragy='$offY' " .
	"src='editor_text.php?lang=$lang&amp;fg=$color&amp;text=$text' title='" .
	htmlspecialchars(sprintf(
	    ($idbaloon == $bal) ? _('move baloon (%d, %d)') : _('edit baloon (%d, %d)'),
	    $loc_1, $loc_2)) .
	"'/>";
    if ($idbaloon != $bal)
	$img = "<a href='?lang=$lang&amp;id=$id&amp;bal=$idbaloon$parms'>$img</a>";
    echo "\t\t$img\n";
}
?>
</div>
</td><td>
<form action="">
<table id="edit" cellspacing="2" cellpadding="0" style="left: <?=$strip['width'] + 5?>px;">
    <tr><td colspan="2"><b><?=_('Browsing')?></b></td></tr>
    <tr><td width="200"><?=_('Language')?></td><td>
	<select name="lang" onchange="if (selectedIndex!=0) window.location.href='?lang='+options[selectedIndex].value+'&amp;id=<?=$id . $parms?>';">
	    <option value=""><?=_('Language')?></option>
<?
$q = $db->prepare("SELECT IDLanguage, Name, Code FROM ${dbprefix}_Languages ORDER BY IDLanguage;");
$q->execute();
$q->setFetchMode(PDO::FETCH_NUM);
while ($row = $q->fetch())
    echo "\t    <option value=\"$row[0]\"" . ($row[0] == $lang ? ' selected' : '') . ">$row[1] ($row[2])</option>\n";
$q->closeCursor();
?>
	</select>
    </td></tr>
    <tr><td><?=_('Strip')?></td><td>
	<select name="strip_id" onchange="if (selectedIndex!=0) window.location.href='?lang=<?=$lang?>&amp;id='+options[selectedIndex].value+'<?=$parms?>';">
	  <option value=""><?=_('MegaTokyo Archives')?></option>
<?
$q = $db->prepare("SELECT IDStrip, Content, Publish FROM ${dbprefix}_Titles WHERE IDLanguage = ? ORDER BY IDStrip DESC;");
$q->execute(array($lang));
$q->setFetchMode(PDO::FETCH_NUM);
while ($row = $q->fetch())
    echo "	  <option value=\"$row[0]\"" . ($row[0] == $id ? ' selected' : '') . '>' . mb_convert_encoding(mydate($row[2], '%Y-%m-%d %a'), "UTF-8", "ASCII") . " [$row[0]] " . htmlspecialchars($row[1], ENT_NOQUOTES, 'UTF-8') . "</option>\n";
$q->closeCursor();
?>
	</select>
    </td></tr>
    <tr><td><?=_('Baloon')?></td><td>
	<select name="idbaloon" onchange="if (selectedIndex!=0) window.location.href='?lang=<?=$lang?>&amp;id=<?=$id?>&amp;bal='+options[selectedIndex].value+'<?=$parms?>';">
	  <option value=""><?=_('Baloon')?></option>
<?
$q = $db->prepare("
    SELECT ${dbprefix}_Baloons.IDBaloon, ${dbprefix}_Baloons.Location, ${dbprefix}_Characters.Name
    FROM ${dbprefix}_Baloons LEFT JOIN ${dbprefix}_Characters ON ${dbprefix}_Baloons.IDCharacter = ${dbprefix}_Characters.IDCharacter
    WHERE ${dbprefix}_Baloons.IDStrip = ? ORDER BY Location, IDBaloon;");
$q->execute(array($id));
$q->setFetchMode(PDO::FETCH_NUM);
while ($row = $q->fetch())
    echo "	  <option value=\"$row[0]\"" . ($row[0] == $bal ? ' selected' : '') . ">$row[0] (" . ((int)($row[1] / 100)) . "," . ((int)($row[1] % 100)) . ') ' . (strlen($row[2]) > 0 ? htmlspecialchars(_($row[2]), ENT_NOQUOTES, 'UTF-8') : '') . "</option>\n";
$q->closeCursor();
?>
	</select>
    </td></tr>
    <tr><td><?=_('Debug')?></td><td><?
	if ($debug)
	    echo "<a href=\"?lang=$lang&amp;id=$id&amp;bal=$bal&amp;debug=0&amp;baloonedit=$baloonedit\">ON</a>";
	else
	    echo "<a href=\"?lang=$lang&amp;id=$id&amp;bal=$bal&amp;debug=1&amp;baloonedit=$baloonedit\">OFF</a>";
    ?></td></tr>
    <tr><td><?=_('Baloon edit')?></td><td><?
	if ($baloonedit)
	    echo "<a href=\"?lang=$lang&amp;id=$id&amp;bal=$bal&amp;debug=$debug&amp;baloonedit=0\">ON</a>";
	else
	    echo "<a href=\"?lang=$lang&amp;id=$id&amp;bal=$bal&amp;debug=$debug&amp;baloonedit=1\">OFF</a>";
    ?></td></tr>
    </form>
<? if ($id) { ?>
    <tr><td><?=_('Locking')?></td><td><?
$row = myqueryR("SELECT Username, Since FROM ${dbprefix}_Lock WHERE IDLanguage = ? AND IDStrip = ?;",
    array($lang, $id));
if ($row)
    printf(_('locked by <b>%1$s</b> on <b>%2$s</b>'), $row[0], $row[1]);
else
    echo _('unlocked');
echo "<br/>\n";
?>
	<form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;bal=<?=$bal . $parms?>" method="post">
	    <input name="type" type="hidden" value="locking"/>
	    <input type="submit" name="lock" value="<?=_('lock')?>">
	    <input type="submit" name="unlock" value="<?=_('unlock')?>">
	</form>
    </td></tr>
<?
}
$row = myqueryR("SELECT Content, Publish, Discussione FROM ${dbprefix}_Titles WHERE IDLanguage = ? AND IDStrip = ?;",
    array($lang, $id));
if ($row) {
    $title = $row[0];
    $publish = $row[1];
    $discussione = $row[2];
} else {
    $title = '';
    $row = myqueryR("SELECT Publish FROM ${dbprefix}_Titles ORDER BY Publish DESC;");
    if ($row)
	$publish = $row[0];
    else
	$publish = date('Y-m-d');
    $discussione = '';
}
?>
    <form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;bal=<?=$bal . $parms?>" method="post">
    <input name="type" type="hidden" value="title"/>
    <input name="idstrip" type="hidden" value="<?=$id?>"/>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2"><b><?=_('This Title')?></b> <?=_('(creation/editing of language-specific strips)')?></td></tr>
    <tr><td><?=_('ID of the Strip')?></td><td><input name="idstrip" type="text" size="10" value="<?=$id?>"/></td></tr>
    <tr><td><?=_('Text')?></td><td><input name="text" type="text" size="40" value="<?=htmlspecialchars($title, ENT_COMPAT, 'UTF-8')?>" onDblClick="this.value=''; return true"/></td></tr>
    <tr><td><?=_('Date of publication')?></td><td><input name="publish" type="text" size="10" maxlength="10" value="<?=$publish?>"/> <?=_('date is in the past')?><input name="publish_ok" type="checkbox" value="1"/></td></tr>
    <tr><td><?=_('Forum thread')?></td><td><input name="discussione" type="text" size="40" value="<?=htmlspecialchars($discussione, ENT_COMPAT, 'UTF-8')?>" onDblClick="this.value=''; return true"/></td></tr>
    <tr><td/><td>
	<input type="submit" name="insert" value="Insert/Update"/>
	<input type="reset" value="Reset"/>
<? if ($config['Local']) { ?>
	<input type="submit" name="fetch" value="Fetch"/>
	<input type="submit" name="send" value="Send"/>
<? } ?>
    </td></tr>
    </form>
    <form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;bal=<?=$bal . $parms?>" method="post" name="myf">
    <input name="type" type="hidden" value="baloon"/>
    <input name="idbaloon" type="hidden" value="<?=$bal?>"/>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2"><b><?=_('This Baloon')?></b> <?=_('(creation/editing of shapes to blank)')?></td></tr>
    <tr><td><?=_('Location')?></td><td><?
	if ($baloonedit) { ?><?=_('panel')?><input name="order1" type="text" size="3" value="<?=$bal_loc_1?>"> <?=_('baloon')?><input name="order2" type="text" size="3" value="<?=$bal_loc_2?>"><?
	} else echo _('panel') . ' <b>' . $bal_loc_1 . '</b> '._('baloon') . ' <b>' . $bal_loc_2 . '</b>'; ?></td></tr>
<? if ($baloonedit) { ?>
    <tr><td><?=_('Shape')?></td><td style="white-space: nowrap;"><input name="coords" type="text" size="40" value="<?=$bal_shp?>"><input type="button" value="poly" onclick="document.myf.coords.value = 'p'; return false;"/></td></tr>
<? } ?>
    <tr><td><?=_('Character')?></td><td><?
if ($baloonedit) { ?><select name="idcharacter">
	<option value="0">------</option>
<?
    $q = $db->prepare("SELECT IDCharacter, Name FROM ${dbprefix}_Characters;");
    $q->execute();
    $q->setFetchMode(PDO::FETCH_NUM);
    $chars = array();
    while ($row = $q->fetch())
	$chars[_($row[1])] = $row[0];
    $q->closeCursor();
    uksort($chars, 'strnatcasecmp');
    foreach($chars as $char => $idchar)
	echo '	<option value="' . $idchar . '"' . ($bal_chr == $idchar ? '" selected>' : '>') . htmlspecialchars($char, ENT_NOQUOTES, 'UTF-8') . "</option>\n";
    unset($chars);
?>
    </select><?
} elseif ($bal_chr)
    echo htmlspecialchars(_(myquery1("SELECT Name FROM ${dbprefix}_Characters WHERE IDCharacter = ?;", array($bal_chr))), ENT_NOQUOTES, 'UTF-8');
?></td></tr>
    <input name="idtext" type="hidden" value="<?
if ($bal) {
    $row = myqueryR("SELECT CenterX, CenterY, Content FROM ${dbprefix}_Texts WHERE IDLanguage = ? AND IDBaloon = ?;",
	array($lang, $bal), PDO::FETCH_ASSOC);
    if ($row) {
	$bal_cx = (string)$row['CenterX'];
	$bal_cy = (string)$row['CenterY'];
    } else {
	// correct language can't be found, find a center from another language as an example
	$row = myqueryR("SELECT CenterX, CenterY, Content FROM ${dbprefix}_Texts WHERE IDBaloon = ? AND (CenterX > 0 OR CenterY > 0);",
	    array($bal), PDO::FETCH_ASSOC);
	if ($row) {
	    $bal_cx = (string)$row['CenterX'];
	    $bal_cy = (string)$row['CenterY'];
	}
	// avoid showing a different language translation
	unset($row);
    }
}
if (!$bal || !isset($row) || !$row)
    $text = '';
else
    $text = $row['Content'];
?>"/>
<? if ($baloonedit) { ?>
    <tr>
      <td><?=_('BG color')?></td>
      <td><input name="colorBG" type="text" size="6" value="<?=$col_bg?>" onDblClick="this.value=''; return true"></td>
    </tr>
    <tr>
      <td><?=_('FG color')?></td>
      <td><input name="colorFG" type="text" size="6" value="<?=$col_fg?>" onDblClick="this.value=''; return true"></td>
    </tr>
<? } ?>
    <tr>
      <td><?=_('Center')?></td>
      <td style="white-space: nowrap;">
	<input name="centerX" type="text" size="6" value="<?=$bal_cx?>" onDblClick="this.value=''; return true"/>x<input name="centerY" type="text" size="6" value="<?=$bal_cy?>" onDblClick="this.value=''; return true"/>
	<? if ($baloonedit) { ?><input type="button" value="Middle" onclick="poly_center();"/><? } ?>
      </td>
    </tr>
    <tr valign="top">
      <td><?=_('Text')?></td>
      <td><textarea name="text" cols="40" rows="6" onDblClick="this.value=''; return true"><?=htmlspecialchars($text, ENT_NOQUOTES, 'UTF-8')?></textarea></td>
    </tr>
    <tr><td/><td><input type="button" value="Trim" onclick="trim_lines();"/><?
if ($bal > 0)
    echo '<input type="submit" name="update" value="Update">';
if ($baloonedit) {
    echo '<input type="submit" name="insert" value="Insert">';
    echo '<input type="submit" name="delete" value="Delete">';
}
?><input type="reset" value="Reset"/></td></tr>
    <tr><td><?=_('Notes')?></td><td style="white-space: nowrap;">
        <table>
<?
$q = $db->prepare("SELECT Translator, Vote, Note FROM ${dbprefix}_Texts_Notes WHERE IDLanguage = ? AND IDBaloon = ? ORDER BY Translator;");
$q->execute(array($lang, $bal));
$q->setFetchMode(PDO::FETCH_NUM);
while ($row = $q->fetch()) {
    $row[0] = htmlspecialchars($row[0]);
    $row[2] = htmlspecialchars($row[2]);
    echo "            <tr><td>$row[0]</td><td align=\"right\"><b>$row[1]</b></td><td>$row[2]</td></tr>\n";
}
$q->closeCursor();
?>
            <tr><td colspan="2">
                <select name="vote">
                    <option>-2</option>
                    <option>-1</option>
                    <option selected="selected">0</option>
                    <option>+1</option>
                    <option>+2</option>
                </select>
            </td><td><input type="text" name="note" size="30"/></td></tr>
        </table>
    </td></tr>
    <tr><td><?=_('Translations')?></td><td style="white-space: nowrap;"><?
$q = $db->prepare("SELECT IDLanguage FROM ${dbprefix}_Texts WHERE IDBaloon = ? AND LENGTH(Content) > 0;");
$q->execute(array($bal));
$q->setFetchMode(PDO::FETCH_NUM);
while ($row = $q->fetch())
    echo "[$row[0]] ";
$q->closeCursor();
?></td></tr>
    </form>
    <tr><td colspan="2">&nbsp;</td></tr>
    <tr><td colspan="2"><b><?=_('Cached Image')?></b> <?=_('(cache-specific commands)')?></td></tr>
    <tr><td>
	<form action="?lang=<?=$lang?>&amp;id=<?=$id?>&amp;bal=<?=$bal . $parms?>" method="post">
	    <input name="type" type="hidden" value="force"/>
	    <input type="submit" name="update" value="<?=_('Force Update')?>">
	</form>
    </td></tr>
    <tr><td colspan="2" height="90%">&nbsp;</td></tr>
</table>
</td></tr>
<tr><td colspan="2">
<table width="700">
    <tr><td colspan="2"><b><?=_('This Console')?></b> <?=_('(insert/update rant texts)')?></td></tr>
    <tr valign="top">
<?
foreach (array('left', 'right') as $pos) {
    $q = $db->prepare("SELECT IDStrip, Username, Title FROM ${dbprefix}_Console WHERE IDLanguage = ? AND IDStrip <= ? AND Position = ? ORDER BY IDStrip DESC LIMIT 3;");
    $q->execute(array($lang, $id, $pos));
    $q->setFetchMode(PDO::FETCH_ASSOC);
    echo "	<td width=\"50%\">\n";
    echo '	    ' . _('Last 3 rants') . ":\n";
    echo "	    <ul>\n";
    $row = $q->fetch();
    if (!$row || ($row['IDStrip'] != $id))
	echo "		<li><a href=\"editor_rant.php?lang=$lang&amp;id=$id&amp;pos=" . substr($pos, 0, 1) . '">' . _('Insert new rant for this strip') . "</a></li>\n";
    do {
	$row['Title'] = htmlspecialchars($row['Title']);
	echo '		<li>' . _('Strip') . " $row[IDStrip]:<br/>\n";
	echo "		    \"<a href=\"editor_rant.php?lang=$lang&amp;id=$row[IDStrip]&amp;pos=" . substr($pos, 0, 1) . "\">$row[Title]</a>\"<br/>\n";
	echo "		    $row[Username]</li>\n";
    } while ($row = $q->fetch());
    echo "	    </ul>\n";
    $q->closeCursor();
}
?>
	</td>
    </tr>
</table>
</td></tr></table>

</body>
</html>
