﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

// This page contains much repeated content
ini_set('zlib.output_compression', TRUE);

// This page shouldn't be cached at all <http://it.php.net/manual/en/function.header.php>
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

chdir('..');
require_once('db.inc.php');

// manage language
require_once('gettext.inc.php');

// manage form
//TODO
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
    <title>MegaLettering editor characters</title>
    <link rel="stylesheet" href="/MTi.css" type="text/css"/>
    <link rel="shortcut icon" href="/image/favicon.ico" type="image/x-icon"/>
    <style type="text/css">
    h1 {
	font-family: monospace;
	font-size: 20pt;
	margin: 0px;
    }
    thead td {
	font-weight: bold;
    }
    </style>
</head>

<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#EB5252" vlink="#ECECA3">

<h1>MegaLettering EDITOR Characters</h1>

<table>
    <tr>
	<td>Editor:</td>
	<td><a href="editor.php?lang=<?=$lang?>">[main]</a></td>
	<td><a href="editor_characters.php?lang=<?=$lang?>">[characters]</a></td>
	<td><a href="editor_style.php?lang=<?=$lang?>">[styles]</a></td>
	<td><!--a href="editor_links.php?lang=<?=$lang?>"-->[links]<!--/a--></td>
    </tr>
</table>

<?
if (isset($errors) && $errors)
    echo "<pre><font color='red'>$errors</font></pre>";

// existing characters table
echo "<table>\n";
echo '  <thead><tr><td>' . _('Untranslated name') . '</td><td>' . _('Translated name') . '</td><td>' . _('Appearances') . "</td></tr></thead>\n";
$q = $db->prepare("
    SELECT
	${dbprefix}_Characters.IDCharacter AS IDCharacter,
	${dbprefix}_Characters.Name AS Name,
	${dbprefix}_Characters.Thread AS Thread,
	MIN(${dbprefix}_Baloons.IDStrip) AS First,
	MAX(${dbprefix}_Baloons.IDStrip) AS Last
    FROM
	${dbprefix}_Characters LEFT JOIN
	${dbprefix}_Baloons ON ${dbprefix}_Characters.IDCharacter = ${dbprefix}_Baloons.IDCharacter
    GROUP BY
	${dbprefix}_Characters.IDCharacter,
	${dbprefix}_Characters.Name,
	${dbprefix}_Characters.Thread
    ORDER BY
	${dbprefix}_Characters.Name;");
$q->execute();
$q->setFetchMode(PDO::FETCH_ASSOC);
while ($row = $q->fetch()) {
    $name = $row['Name'];
    $name2 = _($name);
    //TODO: add '%d time(s)' with COUNT(MTi_Baloons.IDStrip)
    if ($row['First'] && $row['Last'])
	$range = ($row['First'] == $row['Last']) ? $row['First'] : "$row[First] - $row[Last]";
    else
	$range = _('never');
    echo "  <tr><td>$name</td><td>$name2</td><td>$range</td></tr>\n";
}
$q->closeCursor();
echo "</table>\n";
?>

</div>

</body>
</html>
