﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

// This page contains much repeated content
ini_set('zlib.output_compression', TRUE);

// This page shouldn't be cached at all <http://it.php.net/manual/en/function.header.php>
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

chdir('..');
require_once('db.inc.php');
require_once('lib/fckeditor/fckeditor.php') ;

$id = 0;
if (isset($_GET['id']) && is_numeric($_GET['id']))
    $id = (int)$_GET['id'];
$lato = 'left';
if (isset($_GET['pos']) && $_GET['pos']{0} == 'd')
    $lato = 'right';
$username = isset($_SERVER['REMOTE_USER']) ? $_SERVER['REMOTE_USER'] : '';
if ($username == '')
    $username = 'anonymous';

// manage language
require_once('gettext.inc.php');

$errors = '';

$tidy_config = array(
    'ascii-chars' => 0,
    'indent' => 1,
    'language' => 'it',
    'newline' => 'LF',
    'output-bom' => 0,
    'output-xhtml' => 1,
    'quote-ampersand' => 1,
    'quote-marks' => 0,
    'quote-nbsp' => 0,
    'show-body-only' => 1,
    'wrap' => 0,
);
$tidy_context_pre = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html><body>';
$tidy_context_post = '</body></html>';

if (isset($_POST['tipo'])) { // è un inserimento in DB
    $txt = $_POST['text'];
    // add BRs only if there is no BR already
    if (!preg_match('/<\s*br\s*\/?>/i', $txt))
	$txt = preg_replace('/\r?\n/', "<br/>\n", $txt);
    // tidy up the code, so that it is valid nonetheless (and user can modify it, if it changes too much)
    $txt = tidy_repair_string($tidy_context_pre . $txt . $tidy_context_post, $tidy_config, 'UTF8' /* TIDY wants it without - */);
    myupdate("REPLACE INTO ${dbprefix}_Console (IDLanguage, IDStrip, Position, Username, Image, ImageLink, ImageAlt, Title, Content) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?);",
	array($lang, $id, $_POST['position'], $_POST['username'], $_POST['image'], $_POST['imm_link'], $_POST['imm_alt'], $_POST['title'], $txt));
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
    <title>MegaLettering editor rant</title>
    <link rel="stylesheet" href="/MTi.css" type="text/css"/>
    <link rel="shortcut icon" href="/image/favicon.ico" type="image/x-icon"/>
</head>

<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#EB5252" vlink="#ECECA3">

<h1><b><tt>MegaLettering EDITOR rant</tt></b></h1>

<table>
    <tr>
	<td>Editor:</td>
	<td><a href="editor.php?lang=<?=$lang?>&amp;id=<?=$id?>">[main]</a></td>
	<td><a href="editor_characters.php?lang=<?=$lang?>">[characters]</a></td>
	<td><a href="editor_style.php?lang=<?=$lang?>">[styles]</a></td>
	<td><!--a href="editor_links.php?lang=<?=$lang?>"-->[links]<!--/a--></td>
    </tr>
</table>

<?
    $row = myqueryR("SELECT Username, Image, ImageLink, ImageAlt, Title, Content FROM ${dbprefix}_Console WHERE IDLanguage = ? AND IDStrip = ? AND Position = ?;",
	array($lang, $id, $lato), PDO::FETCH_ASSOC);
?>
<form name="rant" action="" method="post">
    <input name="tipo" type="hidden" value="console"/>
    <input name="position" type="hidden" value="<?=$lato?>"/>
    <table border="0">
	<tr>
	    <td>
		<?=_('Username')?><br/>
		<select name="username">
		    <option value="">------</option>
<?
    $q2 = $db->prepare("SELECT Username FROM ${dbprefix}_Staff WHERE IDLanguage = ? ORDER BY Username;");
    $q2->execute(array($lang));
    $q2->setFetchMode(PDO::FETCH_NUM);
    while ($row2 = $q2->fetch())
	echo "		    <option value=\"$row2[0]\"" . ($row2[0] == $row['Username'] ? ' selected' : '') . "> $row2[0]</option>\n";
    myfree($q2);
?>
		</select>
	    </td>
	    <td>
		<?=_('Image')?><br/>
		<select name="image">
		    <option value="">------</option>
<?
    foreach(glob('rantimg/*') as $image)
	echo "		    <option value=\"$image\"" . ($image == $row['Image'] ? ' selected' : '') . '> ' . substr($image, 8) . "</option>\n";
?>
		</select><input type="button" onclick="openEditor(this, '<?=substr($lato, 0, 1)?>'); return false" value="<?=_('editor')?>">
	    </td>
	</tr>
	<tr>
	    <td>
		<?=_('Image link')?><br/>
		<input type=text name="imm_link" size="40" value="<?=htmlspecialchars($row['ImageLink'], ENT_COMPAT, 'UTF-8')?>"/>
	    </td>
	    <td>
		<?=_('Image alternate text')?><br/>
		<input type=text name="imm_alt" size="40" value="<?=htmlspecialchars($row['ImageAlt'], ENT_COMPAT, 'UTF-8')?>"/>
	    </td>
	</tr>
    </table>
    <?=_('Title')?><br/>
    <input type=text name="title" size="80" value="<?=htmlspecialchars($row['Title'], ENT_COMPAT, 'UTF-8')?>"/><br/>
    <?=_('Text')?><br/>
<?
    $txt = $row['Content'];
    // add BRs only if there is no BR already
    if (!preg_match('/<\s*br\s*\/?>/i', $txt))
	$txt = preg_replace('/\r?\n/', "<br/>\n", $txt);
    // tidy up the code, so that it is valid nonetheless (and user can modify it, if it changes too much)
    $txt = tidy_repair_string($tidy_context_pre . $txt . $tidy_context_post, $tidy_config, 'UTF8' /* TIDY wants it without - */);

    $o = new FCKeditor('text') ;
    $o->Height = 300;
    $o->BasePath = '/lib/fckeditor/';
    $o->Value = $txt;
    $o->ToolbarSet = 'Megatokyo';
    $o->Create();
?>
    <br/>
    <input type="submit" value="Update"><input type="reset" value="Reset">
</form>

<script type="text/javascript">
function openEditor(field, lato) {
    window.open('editor_rantimg.php', 'rantimg', 'width=380, height=610, screenX=0, screenY=0, scrollbars=yes');
}
</script>

</body>
</html>
