﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

// This page contains much repeated content
ini_set('zlib.output_compression', TRUE);

// This page shouldn't be cached at all <http://it.php.net/manual/en/function.header.php>
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');

chdir('..');
require_once('db.inc.php');

// manage language
require_once('gettext.inc.php');

// manage form
$default_style = '';
$default_font = '';
$default_size = '8.00';
$errors = '';
if (isset($_POST['add'])) {
    if (strlen($_POST['name']) == 0)
	$errors .= _('Style name must be specified.') . "\n";
    elseif (!preg_match('/^[a-z][a-z0-9_]*$/', $_POST['name']))
	$errors .= _('Style name doesn\'t match /^[a-z][a-z0-9_]*$/');
    if (strlen($_POST['font']) == 0)
	$errors .= _('Font name must be specified.') . "\n";
    if (strlen($_POST['size']) == 0)
	$errors .= _('Font dimension must be specified.') . "\n";
    elseif (!preg_match('/^[0-9]+(\.[0-9]+)?$/', $_POST['size']))
	$errors .= _('Font dimension doesn\'t match /^[0-9]+(\.[0-9]+)?$/');
    $default_style = $_POST['name'];
    $default_font = $_POST['font'];
    $default_size = sprintf('%.2F', $_POST['size']);
    $style = myescape($default_style);
    $font = myescape($default_font);
    $dim = $default_size;
    if (!$errors)
	myupdate("REPLACE INTO ${dbprefix}_Styles (Name, Font, Size) VALUES (?, ?, ?);",
	    array($style, $font, $dim));
} elseif (isset($_POST['del'])) {
    if (strlen($_POST['style_del']) == 0)
	$errors .= _('Style name must be specified.') . "\n";
    if (!preg_match('/^[a-z][a-z0-9_]*$/', $_POST['style_del']))
	$errors .= _('Style name doesn\'t match /^[a-z][a-z0-9_]*$/');
    if (!$errors) {
	$default_style = $_POST['style_del'];
	$style = myescape($default_style);
	$val = myquery1("SELECT Font, Size FROM ${dbprefix}_Styles WHERE Name = ?;", array($style));
	if ($val) {
	    $default_font = $val['Font'];
	    $default_size = $val['Size'];
	    print_r($val);
	}
	myupdate("DELETE FROM ${dbprefix}_Styles WHERE Name = ?;", array($style));
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
    <title>MegaLettering editor fonts</title>
    <link rel="stylesheet" href="/MTi.css" type="text/css"/>
    <link rel="shortcut icon" href="/image/favicon.ico" type="image/x-icon"/>
    <style type="text/css">
    #head {
	position: absolute;
	top: 0px;
	left: 0px;
	width: 100%;
	padding: 10px;
	background-color: #4C565E;
	overflow: hidden;
    }
    body > #head {
	position: fixed;
    }
    #main {
	padding-top: 150px;
    }
    H1 {
	font-family: monospace;
	font-size: 20pt;
	margin: 0px;
    }
    </style>
</head>

<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#EB5252" vlink="#ECECA3">

<div id="head">

<h1>MegaLettering EDITOR Styles</h1>

<table>
    <tr>
	<td>Editor:</td>
	<td><a href="editor.php?lang=<?=$lang?>">[main]</a></td>
	<td><a href="editor_characters.php?lang=<?=$lang?>">[characters]</a></td>
	<td><a href="editor_styles.php?lang=<?=$lang?>">[styles]</a></td>
	<td><!--a href="editor_links.php?lang=<?=$lang?>"-->[links]<!--/a--></td>
    </tr>
</table>

<img id="preview" src="editor_style_preview.php?font=arial&amp;size=8.5&amp;text=default"/>

</div>

<script type="text/javascript">
function update_preview(font, dim) {
    if (!font || !dim) {
	font = document.forms[0]['font'].value;
	dim = document.forms[0]['size'].value;
    }
    document.getElementById('preview').src = 'editor_style_preview.php?font=' + font + '&size=' + dim;
    return false;
}
</script>

<div id="main">

<?
if ($errors)
    echo "<pre><font color='red'>$errors</font></pre>";

// fonts list
$fonts = array();
foreach(glob('font/*') as $font)
    $fonts[substr($font, 5)] = 1;

// styles table
echo '<form method="POST"><input type="hidden" name="style_del" value=""><table>' . "\n";
echo '  <tr><td><input type=text name=name size=20 value="' . htmlentities($default_style). '"></td>';
echo '<td align="right"><input type=text name=size size=5 value="' . htmlentities($default_size). '"></td>';
echo '<td><select name=font>';
foreach(array_keys($fonts) as $font)
    echo '<option' . ($font == $default_font ? ' selected="selected">' : '>') . htmlentities($font) . '</option>';
echo '</select></td><td><input type="button" value="' . _('preview') . '" onclick="update_preview();">&nbsp;<input type="submit" name="add" value="' . _('add/modify') . "\"></td></tr>\n";
$q = $db->prepare("SELECT Name, Font, Size FROM ${dbprefix}_Styles ORDER BY Name;");
$q->execute();
$q->setFetchMode(PDO::FETCH_ASSOC);
while ($row = $q->fetch())
    echo "  <tr><td>$row[Name]</td><td align=\"right\">$row[Size]</td><td" . (isset($fonts[$row['Font']]) ? '' : ' bgcolor="#7F0000"') . ">$row[Font]</td><td> <input type=button value=\"" . _('preview') . "\" onclick=\"update_preview('$row[Font]', $row[Size]);\">&nbsp;<input type=submit name=\"del\" value=\"" . _('delete') . "\" onclick=\"document.forms[0]['style_del'].value='$row[Name]';\"></td></tr>\n";
$q->closeCursor();
echo "</table></form>\n";
?>

</div>

</body>
</html>
