﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

chdir('..');

// no error should be printed at all: output is image/png, not text/*
ob_start();

$font = 'arial';
if (isset($_GET['font']))
    $font = preg_replace('|/|', '', $_GET['font']);
$size = 8.00;
if (isset($_GET['size']))
    $size = (float)$_GET['size'];
$text = 'ABCPFL 0123 ÀÈÈÉÌÒÙ
abcpfl 0123 àèèéìòù';
if (isset($_GET['text']))
    $text = substr($_GET['text'], 0, 50);
$text = "$font $size\n$text";
$colorFGenc = 0x000000;
if (isset($_GET['fg']))
    $colorFGenc = hexdec($_GET['fg']);
$colorBGenc = 0xFFFFFF;
if (isset($_GET['bg']))
    $colorBGenc = hexdec($_GET['bg']);

// send correct headers
header('Content-Type: image/png');

if (function_exists('ImageColorClosestHWB'))
    $closest = 'ImageColorClosestHWB';
elseif (function_exists('ImageColorClosest'))
    $closest = 'ImageColorClosest';
else {
    error_log('No ImageColor* function found in ' . __FILE__ . ':' . __LINE__);
    return FALSE;
}

function CreateTextImage($font, $size, $text, $colorFGenc, $colorBGenc) {
    global $closest;

    if (!file_exists($font))
	$font = "font/$font";
    if (!file_exists($font))
	$font = "$font.ttf";

    $bb = ImageTTFBBox($size, 0, $font, $text);
    $x = min($bb[4] - $bb[0], 1000);
    $y = min($bb[1] - $bb[5], 200);
    $text_line = split("[\r\n]", $text);
    $bb = ImageTTFBBox($size, 0, $font, $text_line[0]);
    $pos_x = 0;
    $pos_y = -$bb[5];

    if (!$img = ImageCreateTrueColor($x, $y)) return FALSE;

    // finds the colors
    $colorFG = $closest($img, ($colorFGenc >> 16) & 0xFF, ($colorFGenc >> 8) & 0xFF, $colorFGenc & 0xFF);
    $colorBG = $closest($img, ($colorBGenc >> 16) & 0xFF, ($colorBGenc >> 8) & 0xFF, $colorBGenc & 0xFF);

    ImageFilledRectangle($img, 0, 0, $x, $y, $colorBG);
    ImageTTFText($img, $size, 0, $pos_x, $pos_y, $colorFG, $font, $text);

    return $img;
}

$img = CreateTextImage($font, $size, $text, $colorFGenc, $colorBGenc);

// check for errors and manage them
$errors = ob_get_contents();
ob_end_clean();
if ($errors)
    $img = CreateTextImage('arial', 8.00, $errors, $colorFGenc, $colorBGenc);

// streams out the resulting image
ImagePNG($img, null, 9);

// clears the buffers
ImageDestroy($img);
?>
