﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
//
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

chdir('..');
require_once('image.inc.php');

// no error should be printed at all: output is image/png, not text/*
ob_start();

$lang = $_GET['lang'];
if (!isset($_GET['lang'])) {
    header('HTTP/1.1 400 formato non valido'); //TODO
    die("'lang' must be specified.");
}
if (!isset($_GET['text'])) {
    header('HTTP/1.1 400 TODO: formato non valido');
    die("'text' must be specified.");
}
$text = split("\r?\n", $_GET['text']);
$colorFGenc = 0x000000;
if (isset($_GET['fg']))
    $colorFGenc = hexdec($_GET['fg']);

// calculates the defaults
$style_default = myquery1("SELECT Default_Style FROM ${dbprefix}_Languages WHERE IDLanguage = ?;", array($lang));
if ($style_default === FALSE)
    $style_default = 'normal';
$align_default = 'center';

// find the size
$align = $align_default;
$text_style = MyImageTTFBBox_Baloon($text, $style_default, $align);
$size_x = $size_y = 0;
foreach ($text_style as $line) {
    $size_x = max($size_x, $line['bbox']['width']);
    $size_y += $line['bbox']['height'];
}

// create the image
$img = ImageCreateTrueColor($size_x, $size_y);
ImageAlphaBlending($img, false);
ImageSaveAlpha($img, true);
$colorFG = ImageColorAllocate($img, ($colorFGenc >> 16) & 0xFF, ($colorFGenc >> 8) & 0xFF, $colorFGenc & 0xFF);
$colorBG = ImageColorAllocateAlpha($img, 0, 0, 0, 127 /*transparent*/);
switch($align) {
case 'left':
    $pos_x = 0;
    break;
case 'center':
    $pos_x = (int)($size_x / 2);
    break;
case 'right':
    $pos_x = $size_x;
    break;
default:
    die("unexpected alignment: [$align]"); //TODO
}
$pos_y = (int)($size_y / 2);
ImageFilledRectangle($img, 0, 0, $size_x - 1, $size_y - 1, $colorBG);
MyImageTTF_Baloon($img, $text, $style_default, $align_default, $pos_x, $pos_y, $colorFG, $colorBG /*hidden debug*/);

// check for errors and manage them
$errors = ob_get_contents();
ob_end_clean();
if ($errors) {
    header('HTTP/1.1 400 TODO: formato non valido');
    die($errors);
}

// send correct headers
header('Content-Type: image/png');
header('Cache-Control: max-age=86400'); // cache for 1 day

// streams out the resulting image
ImagePNG($img, null, 9);

// clears the buffers
ImageDestroy($img);
?>
