﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

ini_set('zlib.output_compression', TRUE);

chdir('..');
require_once('db.inc.php');
require_once('gettext.inc.php');
// override content-type
header('Content-Type: text/plain;charset=UTF-8');

// UTF-8 Byte-Order-Marker (so that many text editor recognize it as UTF-8 automatically)
$BOM = "\xEF\xBB\xBF";

// GET params
$first = 0;
$last = 1000000;
if (isset($_GET['from']) && is_numeric($_GET['from']))
    $first = (int)$_GET['from'];
if (isset($_GET['to']) && is_numeric($_GET['to']))
    $last = (int)$_GET['to'];

echo "${BOM}Storyboard for language $lang_name\r\n";

$q = $db->prepare("
    SELECT
	${dbprefix}_Baloons.IDStrip, ${dbprefix}_Baloons.IDBaloon,
	${dbprefix}_Titles.Content AS Title,
	${dbprefix}_Baloons.Location, ${dbprefix}_Characters.Name,
	${dbprefix}_Baloons.ColorBG, ${dbprefix}_Baloons.ColorFG,
	${dbprefix}_Texts.CenterX, ${dbprefix}_Texts.CenterY, ${dbprefix}_Texts.Content
    FROM
	${dbprefix}_Baloons
	LEFT JOIN ${dbprefix}_Texts ON ${dbprefix}_Baloons.IDBaloon = ${dbprefix}_Texts.IDBaloon
	    AND ${dbprefix}_Texts.IDLanguage = ?
	LEFT JOIN ${dbprefix}_Titles ON ${dbprefix}_Baloons.IDStrip = ${dbprefix}_Titles.IDStrip
	    AND ${dbprefix}_Titles.IDLanguage = ?
	LEFT JOIN ${dbprefix}_Characters ON ${dbprefix}_Baloons.IDCharacter = ${dbprefix}_Characters.IDCharacter
    WHERE
	${dbprefix}_Baloons.IDStrip BETWEEN ? AND ?
    ORDER BY
	${dbprefix}_Baloons.IDStrip, ${dbprefix}_Baloons.Location, ${dbprefix}_Baloons.IDBaloon;
");
//TODO: verify that "a >= b AND a <= c" is the same as "a BETWEEN b AND c"
$q->setFetchMode(PDO::FETCH_ASSOC);
$q->execute(array($lang, $lang, $first, $last));

$last_idstrip = -1;
$last_panel = -1;
while ($row = $q->fetch()) {
    if ($row['IDStrip'] != $last_idstrip) {
	echo "\n======== " . _('Strip') . " #$row[IDStrip]: $row[Title]\r\n";
	$last_idstrip = (int)$row['IDStrip'];
	$last_panel = -1;
    }
    $loc = (int)$row['Location'];
    $loc_1 = (int)($loc / 100);
    $loc_2 = (int)($loc % 100);
    if ($loc_1 != $last_panel) {
	echo '==== ' . _('panel') . " #$loc_1\r\n";
	$last_panel = $loc_1;
    }
    if ($loc == 0)
	echo '** ' . _('WARNING: unset location') . "\r\n";
    echo "== $row[Name] [" . _('baloon') . " #$row[IDBaloon]]\r\n";
    echo "$row[Content]\r\n";
}
?>
