﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('config.inc.php');

define('ISO_DATE', '%Y-%m-%d'); // formato data standard ISO 8601
define('ISO_DATE_COMPLETE', '%Y-%m-%d %H:%M:%S');

function inline_backtrace($bt, $max = 3) {
    $u = '';
    $max = min($max, count($bt));
    for ($i = 0; $i < $max; ++$i)
	$u .= basename($bt[$i]['file']) . ':' . $bt[$i]['line'] . ',';
    return $u;
}

//function myqueryerror($q, $die = true) {
//    global $conn;
//    $type = substr($q, 0, 6);
//    if ($type == 'SELECT')
//	$err = _('I can\'t query the DB');
//    elseif ($type == 'INSERT')
//	$err = _('I can\'t insert in the DB');
//    elseif ($type == 'DELETE')
//	$err = _('I can\'t remove from the DB');
//    elseif ($type == 'UPDATE')
//	$err = _('I can\'t update the DB');
//    elseif ($type == 'REPLACE')
//	$err = _('I can\'t replace in the DB');
//    else
//	$err = _('DB error in unknown query type');
//    //TODO eccezioni con bt interno
//    $err = $err . ': ' . myerror($q);
//    $err .= ' [' . inline_backtrace(debug_backtrace(), 3) . ']';
//    error_log($err);
//    if ($die)
//	die($err);
//}

function mydate($d = NULL, $fmt = ISO_DATE) {
    if (!isset($d))
	$txt = strftime($fmt);
    elseif (is_numeric($d))
	$txt = strftime($fmt, $d);
    else
	$txt = strftime($fmt, strtotime($d));
    return $txt;
}

/** Executes the given query and returns only the first row of the result. */
function myqueryR($query, $param = array(), $type = PDO::FETCH_NUM) {
    global $db;
    $q = $db->prepare($query);
    if (!$q)
	return FALSE;
    if (!$q->execute($param))
	return FALSE;
    $row = $q->fetch($type);
    $q->closeCursor();
    return $row;
}

/** Executes the given query and returns only the first column of the first row of the result. */
function myquery1($query, $param = array()) {
    $row = myqueryR($query, $param);
    return isset($row[0]) ? $row[0] : FALSE;
}

/** Executes the given query and returns boolean status. */
function myupdate($query, $param = array()) {
    global $db;
    $q = $db->prepare($query);
    if (!$q)
	return FALSE;
    return $q->execute($param);
}

$db = new PDO($config['DB']['DSN'],
    $config['DB']['username'], $config['DB']['password'],
    array(PDO::ATTR_PERSISTENT => true));
$db->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
$dbprefix =& $config['DB']['prefix'];

if (substr($config['DB']['DSN'], 0, 7) == 'sqlite:') {
    function udf_curdate()            { return strftime(ISO_DATE); }
    function udf_now()                { return strftime(ISO_DATE_COMPLETE); }
    function udf_unix_timestamp($str) { return strtotime($str); }
    function udf_year($str)           { return (int)strftime('%Y', strtotime($str)); }
    function udf_month($str)          { return (int)strftime('%m', strtotime($str)); }
    function udf_day($str)            { return (int)strftime('%d', strtotime($str)); }
    $db->sqliteCreateFunction('curdate',        'udf_curdate',        0);
    $db->sqliteCreateFunction('now',            'udf_now',            0);
    $db->sqliteCreateFunction('unix_timestamp', 'udf_unix_timestamp', 1);
    $db->sqliteCreateFunction('year',           'udf_year',           1);
    $db->sqliteCreateFunction('month',          'udf_month',          1);
    $db->sqliteCreateFunction('day',            'udf_day',            1);
} else {
    myupdate('SET CHARACTER SET utf8;');
}
?>
