﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('db.inc.php');
require_once('sessions.inc.php');

function SetLanguage($l) {
    global $dbprefix, $lang, $lang_code, $lang_name, $lang_active;
    $l = strtolower(substr($l, 0, 2));
    if ($l == 'en') {
	// english is the ultimate-default, always valid
	$lang = 'en';
	$lang_code = 'en_US.US-ASCII';
	$lang_name = 'English';
	$lang_active = TRUE;
	return true;
    }
    if (!preg_match('/^[a-z]{2}$/', $l))
	return false;
    if ($row = myqueryR("SELECT Code, Name, Active FROM ${dbprefix}_Languages WHERE IDLanguage = ?;", array($l))) {
	$lang = $l;
	$lang_code = (string)$row[0];
	$lang_name = (string)$row[1];
	$lang_active = (bool)$row[2];
	return true;
    }
    return false;
}

(isset($lang) && SetLanguage($lang))
|| (isset($_GET['lang']) && SetLanguage($_GET['lang']))
|| (($_SESSION['lang'] == 'prev') && isset($_SESSION['lastlang']) && SetLanguage($_SESSION['lastlang']))
|| (($_SESSION['lang'] == 'brow') && isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) && SetLanguage($_SERVER['HTTP_ACCEPT_LANGUAGE']))
|| (($_SESSION['lang'] != 'prev') && ($_SESSION['lang'] != 'brow') && SetLanguage($_SESSION['lang']))
|| (isset($_SERVER['HTTP_HOST']) && SetLanguage(substr($_SERVER['HTTP_HOST'], -2)))
|| SetLanguage('en');

setlocale(LC_ALL, $lang_code);
mb_internal_encoding('UTF-8');
putenv("LC_ALL=$lang"); // needed by gettext, dunno why
bindtextdomain('MegaLettering', 'gettext/') or die('Translation directory not found.');
bind_textdomain_codeset('MegaLettering', 'UTF-8');
textdomain('MegaLettering');
header('Content-Type: text/html;charset=UTF-8');
header('Content-Style-Type: text/css');
header('Content-Script-Type: text/javascript');
header("Content-Language: $lang");
?>
