<?php
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>
// this file is not part of MegaLettering and is not covered by its license

ini_set('zlib.output_compression', TRUE);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

require_once('config.inc.php');
require_once('db.inc.php');
require_once('image.inc.php');
require_once('rewrite.inc.php');
require_once('sessions.inc.php');
require_once('strip_navigation.inc.php');
require_once('stats.inc.php');

// manage language
require_once('gettext.inc.php');

// manage GET parameters
$id = 0; // default is 'last strip'
if (isset($_GET['id']) && is_numeric($_GET['id']))
    $id = (int)$_GET['id'];
else switch($_SESSION['id']) {
    case 'prev':
	if (isset($_SESSION['lastid'][$lang]))
	    $id = $_SESSION['lastid'][$lang];
	break;
    case 'first':
	$id = 1;
	break;
    // case 'last': // this case is the default anyway
}
$god = FALSE;
if (isset($_SESSION['god']) && $_SESSION['god'])
    $god = TRUE;
if (isset($_GET['god'])) {
    if ($_GET['god'] == $config['god']) {
	$god = TRUE;
	$_SESSION['god'] = TRUE;
    } else {
	$god = FALSE;
	unset($_SESSION['god']);
    }
}
$checkdata = $god ? '' : ' AND Publish <= NOW()';

$header_extended = isset($header_extended) && ($header_extended === true);
if ($header_extended) {
    // find last strip
    $id_last = find_strip('MAX');
    // find current strip (last visible strip <= the one selected)
    if ($id == 0) // if no strip was selected
	$id = $id_last; // then show the last one
    else
	$id = find_strip('MAX', '<=', $id);
    // find prev strip
    $id_prev = find_strip('MAX', '<', $id);
    // find next strip
    $id_next = find_strip('MIN', '>', $id);
}

// check for rewritten URL, else redirect
if ($config['URLRewrite'] && ($_SERVER['SCRIPT_NAME'] == '/index.php') && isset($_GET['id'])) {
    $rewritten = GetURL($id, $lang);
    if (strpos($_SERVER['HTTP_USER_AGENT'], '(compatible; Konqueror/') !== FALSE)
	; // redirect is broken, see: http://bugs.kde.org/show_bug.cgi?id=130573
    elseif ($rewritten != preg_replace('/\?.*$/', '', urldecode($_SERVER['REQUEST_URI']))) {
	if (isset($_GET['lang']) && isset($_GET['id']))
	    header('HTTP/1.1 301 Moved Permanently');
	header('Location: http://' .
	    $_SERVER['SERVER_NAME'] .
	    ($_SERVER['SERVER_PORT'] == 80 ? '' : ':' . $_SERVER['SERVER_PORT']) .
	    $rewritten .
	    (isset($_GET['char']) ? '?char=' . (int)$_GET['char'] : '') .
	    (isset($_GET['story']) ? '?story=' . (int)$_GET['story'] : ''));
	exit();
    }
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?=$lang?>" xml:lang="<?=$lang?>">
<head>
  <title><?=_('MegaTokyo - relax, we understand j00')?><?=$header_extended ? ' - ' . GetStripTitle($id, $lang) : ''?></title>
  <meta name="Description" content="Traduzione italiana di MegaTokyo.com di Fred 'Piro' Gallagher"/>
  <meta http-equiv="author" content="Frederick M. Gallagher III &amp; Rodney L. Caston"/>
  <meta http-equiv="keywords" lang="en" content="megatokyo, megatokyo.com, online comic, gaming, japanese animation, anime, fan art, pop culture, japan, nihongo, nihonjin, painter, otaku, photoshop, fansubs, computer graphics,rodney l caston, fred gallagher, sempai"/>
  <meta http-equiv="keywords" lang="it" content="megatokyo, megatokyo.it, megatokyo.com, fumetto online, gaming, animazione giapponese, anime, fan art, pop culture, giappone, nihongo, nihonjin, disegnatore, otaku, photoshop, fansubs, computer grapfica, rodney l caston, fred gallagher, sempai, lapo luchini, megatokio"/>
  <meta http-equiv="distribution" content="global"/>
  <link rel="stylesheet" href="/image/main.css" type="text/css"/>
<? if ($lang == 'it') { ?>
  <link rel="stylesheet" href="http://www.nuvolelettriche.it/feed_html.css" type="text/css"/>
<? } ?>
  <link rel="shortcut icon" href="/image/favicon.ico" type="image/x-icon"/>
  <link rel="made" title="Megatokyo.it webmaster" href="mailto:lapo@megatokyo.it?subject=Feedback from megatokyo.it"/>
  <link rel="copyright" title="Original author" href="mailto:piro@megatokyo.com?subject=Feedback from megatokyo.it"/>
  <link rel="alternate" title="Original" href="http://www.megatokyo.com/"/>
  <link rel="alternate" title="Deutsch" href="http://www.megatokyo.de/"/>
  <link rel="alternate" title="Italian" href="http://www.megatokyo.it/"/>
  <link rel="alternate" type="application/rss+xml" title="MegaTokyo (<?=strtoupper($lang)?>)" href="/newsfeed.php?lang=<?=$lang?>"/>
  <link rel="forum" title="Forum (translations)" href="http://forum.m4d.it/forumdisplay.php?forumid=1340"/>
  <link rel="forum" title="Forum (original)" href="http://forums.megatokyo.com/"/>
  <link rel="home" href="/"/>
<?
if ($header_extended) {
    // print rest of navigation bar
    if ($id_last && ($id_last != $id))
	echo "  <link rel=\"last\" href=\"/?lang=$lang&amp;id=$id_last\"/>\n";
    if ($id != 1)
	echo "  <link rel=\"first\" href=\"/?lang=$lang&amp;id=1\"/>\n";
    if ($id_prev && ($id_prev != $id))
	echo "  <link rel=\"prev\" href=\"/?$lang=$lang&amp;id=$id_prev\"/>\n";
    if ($id_next && ($id_next != $id))
	echo "  <link rel=\"next\" href=\"/?$lang=$lang&amp;id=$id_next\"/>\n";
}

// update session data
$_SESSION['lastid'][$lang] = $id;
$_SESSION['lastlang'] = $lang;
?>
</head>
<body bgcolor="#4C565E" text="#E4E4D6" link="#F6B33D" alink="#F6B33D" vlink="#F6B33D">
<center>
<?
if (file_exists("lang_$lang/header.inc.php")) {
    include("lang_$lang/header.inc.php");
} else {
    include('lang_en/header.inc.php');
}
?>
