﻿<?php
ini_set('zlib.output_compression', TRUE);
header("Content-type: text/html;charset=UTF-8");
header("Content-language: en");
// 65.41 html zozzo iniziale
// 57.24 verde di default
// 57.79 con i CSS
// 61.12 validato
// 44.02 CSS migliorati
//  2.28 ob_gzhandler

// ricevo i parametri GET
$num = '00';
if(isset($_GET['num']))
    $num = substr('0' . (int)$_GET['num'], -2);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title>Realtime CVS stats</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
  <!--link rel="stylesheet" href="image/main.css" type="text/css"/-->
  <style type="text/css">
  H1 {
    font-family: verdana, arial, helvetica, sans-serif;
  }
  TD {
    font-family: verdana, arial, helvetica, sans-serif;
    font-weight: bold;
    color: black;
    background-color: #00FF00;
    width: 20%;
  }
  TD.b { background-color: #0000FF; }
  TD.bc { background-color: #8080FF; }
  TD.rv1 { background-color: #30C000; }
  TD.rv2 { background-color: #609000; }
  TD.rv3 { background-color: #906000; }
  TD.rv4 { background-color: #C03000; }
  TD.r { background-color: #FF0000; }
  TD.w { background-color: #FFFFFF; }
  </style>
</head>
<body>
<h1>Realtime CVS stats</h1>
<?
$status = array(); // status of each strip
$TBAs = array(); // number of TBAs for each person

// analisi del file
$f = fopen("../MTi-$num.txt", 'rb'); // realtime copy
$line_num = 0;
$id = 0;
while(!feof($f)) {
    $s = fgets($f);
    $line_num++;
    if(preg_match('/^([0-9]{4}) .*$/', $s, $m)) {
	$id = (int)$m[1];
	//echo "STRIP: $id\n";
	$status[$id] = array('TRAD' => FALSE, 'TBL' => FALSE, 'TBA' => 0, 'TODO' => 0, 'TOFONT' => 0);
    } elseif($id) {
	if(preg_match('/^# *(TB(L|A-([a-z0-9]+)) *)*$/', $s)) {
	    //echo "MATCH: $s\n";
	    $last = 1;
	    while(preg_match('/^ *TB(L|A-([a-z0-9]+))/', substr($s, $last), $m, PREG_OFFSET_CAPTURE)) {
		//print_r($m);
		switch($m[1][0][0]) {
		    case 'L':
			//echo 'TBL ';
			$status[$id]['TBL'] = TRUE;
			$last += $m[1][0] + 1;
			break;
		    case 'A':
			//echo 'TBA-' . $m[2][0] . ' ';
			$status[$id]['TBA']++;
			if($status[$id]['TRAD']) {
			    if(!isset($TBAs[$m[2][0]]))
				$TBAs[$m[2][0]] = 1;
			    else
				$TBAs[$m[2][0]]++;
			}
			$last += $m[2][1] + strlen($m[2][0]);
			break;
		    //default:
			//echo "UNKNOWN TB.\n";
		}
		//echo "\n";
	    }
	} elseif(preg_match('/^\*/', $s))
	    $status[$id]['TRAD'] = TRUE;
	elseif(preg_match('/TODO/', $s))
	    $status[$id]['TODO']++;
	elseif(preg_match('/TOFONT/', $s))
	    $status[$id]['TOFONT']++;
    }
}
fclose($f);

// stampa sunto TBA
arsort($TBAs);
echo "<table>\n";
echo '<tr><td class="w">Nome</td><td class="w">TBA</td></tr>' . "\n";
foreach($TBAs as $key => $value) {
    switch($value['TBA']) {
	case 0: $colorA = ''; break;
	case 1: $colorA = ' class="rv1"'; break;
	case 2: $colorA = ' class="rv2"'; break;
	case 3: $colorA = ' class="rv3"'; break;
	case 4: $colorA = ' class="rv4"'; break;
       default: $colorA = ' class="r"'; break;
    }
    echo "<tr><td class=\"b\">$key</td><td$colorA>$value</td></tr>\n";
}
echo "</table>\n";

// stampa sunto vignette
echo "<table>\n";
echo '<tr><td class="w">Strip</td><td class="w">TODO</td><td class="w">TOFONT</td><td class="w">TBA</td><td class="w">TBL</td></tr>' . "\n";
foreach($status as $key => $value) {
    $id = substr('000' . $key, -4);
    $colorI = ($value['TRAD'] ? ' class="b"' : ' class="bc"');
    switch($value['TBA']) {
	case 0: $colorA = ''; break;
	case 1: $colorA = ' class="rv1"'; break;
	case 2: $colorA = ' class="rv2"'; break;
	case 3: $colorA = ' class="rv3"'; break;
	case 4: $colorA = ' class="rv4"'; break;
       default: $colorA = ' class="r"'; break;
    }
    $colorL = ($value['TBL'] ? ' class="r"' : '');
    $colorD = ($value['TODO'] ? ' class="r"' : '');
    $colorF = ($value['TOFONT'] ? ' class="r"' : '');
    echo "<tr><td$colorI>$id</td><td$colorD>$value[TODO]</td><td$colorF>$value[TOFONT]</td><td$colorA>$value[TBA]</td><td$colorL>&nbsp;</td></tr>\n";
}
echo "</table>\n";
?>
</body>
</html>

