﻿<?
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2007 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

ob_start();

require_once('../db.inc.php');
require_once('../safe_envelope.inc.php');

$lang = 'it';
if(isset($_SERVER['HTTP_HOST']))
    $lang = substr($_SERVER['HTTP_HOST'], -2);
if(isset($_GET["lang"]))
    $lang = substr($_GET["lang"], 0, 2);
$id = 0;
if(isset($_GET['id']) && is_numeric($_GET['id']))
    $id = (int)$_GET['id'];

// manage language
require_once('gettext.php');

// override content-type
header("Content-type: application/x-bzip2");

$arr1 = sqlite_array_query($conn, <<<EOQ
SELECT
    ${dbprefix}_Baloons.IDBaloon AS IDBaloon,
    ${dbprefix}_Baloons.Location AS Location,
    ${dbprefix}_Baloons.Shape AS Shape,
    ${dbprefix}_Baloons.IDCharacter AS IDCharacter,
    ${dbprefix}_Baloons.ColorBG AS ColorBG,
    ${dbprefix}_Baloons.ColorFG AS ColorFG,
    ${dbprefix}_Texts.CenterX AS CenterX,
    ${dbprefix}_Texts.CenterY AS CenterY,
    ${dbprefix}_Texts.Content AS Content,
    ${dbprefix}_Texts.Translator AS Translator
FROM
    ${dbprefix}_Baloons
    INNER JOIN ${dbprefix}_Texts ON ${dbprefix}_Baloons.IDBaloon = ${dbprefix}_Texts.IDBaloon
WHERE
    ${dbprefix}_Baloons.IDStrip = $id
    AND ${dbprefix}_Texts.IDLanguage = '$lang'
ORDER BY
    ${dbprefix}_Baloons.IDStrip, ${dbprefix}_Baloons.Location, ${dbprefix}_Baloons.IDBaloon
EOQ
) or die(_('I can\'t query the DB: ') . sqlite_error_string(sqlite_last_error($conn)));
for($j = count($arr) - 1; $j >= 0; --$j) {
    for($i = 9; $i >= 0; --$i)
	unset($arr[$j][$i]);
    settype($arr[$j]['IDBaloon'], 'int');
    settype($arr[$j]['Location'], 'int');
    settype($arr[$j]['IDCharacter'], 'int');
    settype($arr[$j]['ColorBG'], 'int');
    settype($arr[$j]['ColorFG'], 'int');
    settype($arr[$j]['CenterX'], 'int');
    settype($arr[$j]['CenterY'], 'int');
}
$arr2 = sqlite_array_query($conn, "
    SELECT
	Content AS Title,
	Publish AS PublishDate,
	Version AS Version,
	Discussione AS ForumLink
    FROM
	${dbprefix}_Titles
    WHERE
	${dbprefix}_Titles.IDStrip = $id
	AND ${dbprefix}_Titles.IDLanguage = '$lang'
;") or die(_('I can\'t query the DB: ') . sqlite_error_string(sqlite_last_error($conn)));
$arr = array(
    'IDLanguage' => $lang,
    'IDStrip' => $id,
    'Version' => $arr2[0]['Version'],
    'Title' => $arr2[0]['Title'],
    'PublishDate' => $arr2[0]['PublishDate'],
    'ForumLink' => $arr2[0]['ForumLink'],
    'Baloons' => $arr1
);
echo safe_send($arr);
?>

