﻿<?
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

ini_set('zlib.output_compression', TRUE);

require_once('../db.inc.php');

// manage language
if(isset($_GET["lang"]))
    $lang = substr($_GET["lang"], 0, 2);
require_once('gettext.php');
// override content-type
header("Content-type: text/plain;charset=UTF-8");

// UTF-8 Byte-Order-Marker (so that many text editor recognize it as UTF-8 automatically)
$BOM = "\xEF\xBB\xBF";

// GET params
$first = 0;
$last = 1000000;
if(isset($_GET['from']) && is_numeric($_GET['from']))
    $first = (int)$_GET['from'];
if(isset($_GET['to']) && is_numeric($_GET['to']))
    $last = (int)$_GET['to'];

echo "${BOM}Storyboard for language $lang_name\r\n";

$q = sqlite_query($conn, <<<EOQ
SELECT
  ${dbprefix}_Baloons.IDStrip AS IDStrip, ${dbprefix}_Baloons.IDBaloon AS IDBaloon,
  ${dbprefix}_Titles.Content AS Title,
  ${dbprefix}_Baloons.Location AS Location, ${dbprefix}_Characters.Name AS Name,
  ${dbprefix}_Baloons.ColorBG AS ColorBG, ${dbprefix}_Baloons.ColorFG AS ColorFG,
  ${dbprefix}_Texts.CenterX AS CenterX, ${dbprefix}_Texts.CenterY AS CenterY,
  ${dbprefix}_Texts.Content AS Content
FROM
  ${dbprefix}_Baloons
  LEFT JOIN ${dbprefix}_Texts ON ${dbprefix}_Baloons.IDBaloon = ${dbprefix}_Texts.IDBaloon
  LEFT JOIN ${dbprefix}_Titles ON ${dbprefix}_Baloons.IDStrip = ${dbprefix}_Titles.IDStrip
  LEFT JOIN ${dbprefix}_Characters ON ${dbprefix}_Baloons.IDCharacter = ${dbprefix}_Characters.IDCharacter
WHERE
  ${dbprefix}_Baloons.IDStrip >= $first
  AND ${dbprefix}_Baloons.IDStrip <= $last
  AND ${dbprefix}_Texts.IDLanguage = '$lang'
  AND ${dbprefix}_Titles.IDLanguage = '$lang'
ORDER BY
  ${dbprefix}_Baloons.IDStrip, ${dbprefix}_Baloons.Location, ${dbprefix}_Baloons.IDBaloon
EOQ
) or die(_('I can\'t query the DB: ') . sqlite_error_string(sqlite_last_error($conn)));

$last_idstrip = -1;
$last_panel = -1;
while($row = sqlite_fetch_array($q)) {
    if($row['IDStrip'] != $last_idstrip) {
	echo "\n======== " . _('Strip') . " #$row[IDStrip]: $row[Title]\r\n";
	$last_idstrip = (int)$row['IDStrip'];
	$last_panel = -1;
    }
    $loc = (int)$row['Location'];
    $loc_1 = (int)($loc / 100);
    $loc_2 = (int)($loc % 100);
    if($loc_1 != $last_panel) {
	echo '==== ' . _('panel') . " #$loc_1\r\n";
	$last_panel = $loc_1;
    }
    if($loc == 0)
	echo '** ' . _('WARNING: unset location') . "\r\n";
    echo "== $row[Name] [" . _('baloon') . " #$row[IDBaloon]]\r\n";
    echo "$row[Content]\r\n";
}
?>

