﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('db.inc.php');
require_once('gettext.inc.php');
require_once('sessions.inc.php');

if (isset($_POST['poll']) && isset($_POST['vote'])
	&& is_numeric($_POST['poll']) && is_numeric($_POST['vote'])) {
    $poll = (int)$_POST['poll'];
    $vote = (int)$_POST['vote'];
    if (($poll > 0) && ($vote > 0)) {
	$sid = $mysess->id();
	$ip = isset($_SERVER['REMOTE_ADDR']) ? myescape($_SERVER['REMOTE_ADDR']) : '';
	// rimettere il DELAYED!
	myupdate("REPLACE INTO ${dbprefix}_Polls_Votes (IDPoll, SID, Value, Date, IP) VALUES (?, ?, ?, NOW(), ?)",
	    array($poll, $sid, $vote, $ip));
    }
}

function PollsDisplay($link, $lang, $onlyNew = true) {
    global $db, $dbprefix, $mysess;
    if ($mysess->count() == 0) // polls are active only for users that use cookies (else they would be bugged and maybe vote on each reload)
	return '';
    $sid = $mysess->id();
    $u = '';
    $where = $onlyNew ? "AND ${dbprefix}_Polls_Votes.Value IS NULL" : '';
    $q = $db->prepare("
	SELECT
	    ${dbprefix}_Polls.IDPoll AS IDPoll,
	    ${dbprefix}_Polls.Name AS Name,
	    ${dbprefix}_Polls.Text AS Text,
	    ${dbprefix}_Polls_Votes.Value AS Value
	FROM
	    ${dbprefix}_Polls LEFT JOIN ${dbprefix}_Polls_Votes
	    ON ${dbprefix}_Polls.IDPoll = ${dbprefix}_Polls_Votes.IDPoll
	    AND ${dbprefix}_Polls_Votes.SID = ?
	WHERE
	    ${dbprefix}_Polls.IDLanguage = ?
	    AND ${dbprefix}_Polls.DateStart <= NOW()
	    AND ${dbprefix}_Polls.DateEnd >= NOW()
	    $where
	ORDER BY
	    ${dbprefix}_Polls.DateStart;
    ");
    $q->setFetchMode(PDO::FETCH_ASSOC);
    $q2 = $db->prepare("SELECT Value, Name FROM ${dbprefix}_Polls_Values WHERE IDPoll = ? ORDER BY Value;");
    $q2->setFetchMode(PDO::FETCH_ASSOC);
    $q->execute(array($sid, $lang));
    while ($row = $q->fetch()) {
	$u .= '<form method="POST"><input type="hidden" name="poll" value="' . $row['IDPoll'] . '">';
	$u .= "<b>$row[Name]</b><br/>";
	$u .= "<i>$row[Text]</i><br/>";
	$q2->execute(array($row['IDPoll']));
	while ($row2 = $q2->fetch()) {
	    $u .= '<input type="radio" name="vote" value="' . $row2['Value'] . '"';
	    if ($row['Value'] == $row2['Value'])
		$u .= ' checked="checked"';
	    $u .= "> $row2[Name]<br/>";
	}
	$q2->closeCursor();
	$u .= '<input type="submit" value="' . _('Vote') . '"></form>';
    }
    $q->closeCursor();
    return $u;
}
?>
