﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
//
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('db.inc.php');

class Session {

    public $db;
    public $data = array();

    public function __destruct() {
	// necessary as it would be otherwise be called after object destroying
	session_write_close();
    }

    public function encode($id) {
	global $config;
	//echo "[encode=$id]";
	//TODO bug in mcrypt: in ecb mode iv should not be required
	$c = @mcrypt_encrypt('rijndael-128', $config['SessionKey'], $id, MCRYPT_MODE_ECB);
	return preg_replace('/=/', '', base64_encode($c));
    }

    public function decode($cid) {
	global $config;
	$p = @mcrypt_decrypt('rijndael-128', $config['SessionKey'], base64_decode($cid), MCRYPT_MODE_ECB);
	$p = trim($p); // remove padding spaces
	//echo "[decode=$cid=$p]";
	if (!is_numeric($p))
	    return FALSE;
	return (int)$p;
    }

    public function id() {
	return $this->data['SID'];
    }

    public function count() {
	return $this->data['Count'];
    }

    public function newid() {
	global $db, $dbprefix;
	$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '';
	myupdate("INSERT INTO ${dbprefix}_Sessions (SID, Value, FirstDate, LastDate, LastIP, Count) VALUES (null, '', NOW(), NOW(), ?, 0)",
	    array($ip));
	$id = $db->lastInsertId(); //TODO got to be sure this is referred to the previous INSERT
	if (!is_numeric($id))
	    return FALSE;
	//echo "[newid=$id]";
	return $this->encode($id);
    }

    public function open($save_path, $session_name) {
	//echo '[open]';
	global $db;
	$this->db = &$db;
	return TRUE;
    }

    public function close() {
	//echo '[close]';
	return TRUE;
    }

    public function read($cid) {
	global $dbprefix;
	$id = $this->decode($cid);
	//echo "[read1=$id]";
	if ($id === false)
	    $id = $this->decode(newid());
	$this->data['SID'] = $id;
	//echo "[read2=$id]";
	$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '';
	$row = myqueryR("SELECT Value, Count FROM ${dbprefix}_Sessions WHERE SID = ?", array($id));
	if ($row) {
	    $this->data['Count'] = (int)$row[1];
	    return $row[0];
	} else {
	    myupdate("INSERT INTO ${dbprefix}_Sessions (SID, Value, FirstDate, LastDate, LastIP, Count) VALUES (?, '', NOW(), NOW(), ?, 0)",
		array($id, $ip));
	    $this->data['Count'] = 0;
	    return '';
	}
    }

    public function write($cid, $data) {
	global $dbprefix;
	$id = $this->decode($cid);
	//echo "[write=$id]";
	$ip = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR'] : '';
	myupdate("UPDATE ${dbprefix}_Sessions SET Value = ?, LastDate = NOW(), LastIP = ?, Count = Count + 1 WHERE SID = ?",
	    array($data, $ip, $id));
	return TRUE;
    }

    public function destroy($id) {
	//echo '[destroy]';
	//TODO why should this be defined? when is it called?
	return TRUE;
    }

    public function gc($maxlifetime) {
	//echo '[gc]';
	//TODO why shuold this be defined? when is it called?
	return TRUE;
    }

}

ini_set('session.name', $config['cookie']);
ini_set('session.use_cookies', 1);
ini_set('session.use_only_cookies', 1);
ini_set('session.cookie_lifetime', 3600*24*365);

$mysess = new Session();
session_set_save_handler(
    array(&$mysess, "open"),
    array(&$mysess, "close"),
    array(&$mysess, "read"),
    array(&$mysess, "write"),
    array(&$mysess, "destroy"),
    array(&$mysess, "gc")
);
if (!isset($_COOKIE[$config['cookie']]))
    session_id($mysess->newid());
session_start();

// manage session data defaults
if (!isset($_SESSION['lastid']))
    $_SESSION['lastid'] = array();
if (!isset($_SESSION['lang']))
    $_SESSION['lang'] = 'prev';
if (!isset($_SESSION['id']))
    $_SESSION['id'] = 'prev';
if (!isset($_SESSION['titles']))
    $_SESSION['titles'] = 10;
if (!isset($_SESSION['life']))
    $_SESSION['life'] = 365;
?>
