﻿<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('db.inc.php');
require_once('sessions.inc.php');

$browsers = array(
    '|^Mozilla/4\.0 \(compatible; MSIE |',
    '|^Mozilla/5\.0 \([^)]*\) Gecko/200|',
    '|^Opera/|',
);

$robots = array(
    '|^Googlebot/|',
    '|^Feedfetcher-Google;|',
    '|^Mediapartners-Google/|',
    '|^Yahoo! Slurp|',
    '|^msnbot[-/]|',
    '|^Netcraft |',
    '|^Pompos/|',
    '|^Scooter/|',
    '|^Gigabot/|',
    '|^ia_archiver$|',
    '|^http://www\.almaden\.ibm\.com/cs/crawler|',
    '|^NaverBot-|',
    '|^EARTHCOM\.info/|',
    '|^Dillo/|', /* check if it is really a robot */
    '|^Mozilla/[0-9.]+ \(compatible; Ask Jeeves/Teoma\)|',
    '|^Mozilla/[0-9.]+ \(compatible; archive\.org_bot\)|',
    '|^HenryTheMiragoRobot \(http://www\.miragorobot\.com|',
    '|^WebReaper |',
    '|^Wget/|',
);

function isRobot($ua) {
    global $browsers, $robots;
    // check for most common browsers (they are few)
    foreach($browsers as $t)
	if (preg_match($t, $ua))
	    return false;
    // then check for the long list of robots
    foreach($robots as $t)
	if (preg_match($t, $ua))
	    return true;
    // then I guess it's not a robot
    return false;
}

function Stats_Strip_Update($lang, $id) {
    global $db, $dbprefix;
    if (isset($_SERVER['HTTP_USER_AGENT']) && isRobot($_SERVER['HTTP_USER_AGENT']))
	return;
    $db->beginTransaction();
    try {
	myupdate("INSERT OR IGNORE INTO ${dbprefix}_Stats (IDLanguage, IDStrip, Date, Count) VALUES (?, ?, CURDATE(), 0)", array($lang, $id));
    } catch (Exception $e) {
	// this can (and probably will) fail
    }
    myupdate("UPDATE ${dbprefix}_Stats SET Count = Count + 1 WHERE IDLanguage = ? AND IDStrip = ? AND Date = CURDATE()", array($lang, $id)); // if this fails we don't want it to stop the page
    $db->commit();
}
?>
