<?php
// MegaLettering translated comics PHP engine
// Copyright (c) 2003-2008 Lapo Luchini <lapo@lapo.it>

// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
// 
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

require_once('db.inc.php');

function strip_export($id, $lang) {
    global $dbprefix, $db;
    // extracts the Strip (generic) infos
    $arr = myqueryR("
	SELECT
	    IDLanguage AS IDLanguage,
	    IDStrip AS IDStrip,
	    Content AS Title,
	    Publish AS PublishDate,
	    Version AS Version,
	    Discussione AS ForumLink
	FROM
	    ${dbprefix}_Titles
	WHERE
	    ${dbprefix}_Titles.IDLanguage = ? AND
	    ${dbprefix}_Titles.IDStrip = ?;
    ", array($lang, $id), PDO::FETCH_ASSOC);
    // extracts the Baloon-specific infos
    $q = $db->prepare("
	SELECT
	    ${dbprefix}_Baloons.IDBaloon AS IDBaloon,
	    ${dbprefix}_Baloons.Location AS Location,
	    ${dbprefix}_Baloons.Shape AS Shape,
	    ${dbprefix}_Baloons.IDCharacter AS IDCharacter,
	    ${dbprefix}_Baloons.ColorBG AS ColorBG,
	    ${dbprefix}_Baloons.ColorFG AS ColorFG,
	    ${dbprefix}_Texts.CenterX AS CenterX,
	    ${dbprefix}_Texts.CenterY AS CenterY,
	    ${dbprefix}_Texts.Content AS Content,
	    ${dbprefix}_Texts.Translator AS Translator
	FROM
	    ${dbprefix}_Baloons LEFT JOIN
	    ${dbprefix}_Texts ON
		${dbprefix}_Baloons.IDBaloon = ${dbprefix}_Texts.IDBaloon AND
		${dbprefix}_Texts.IDLanguage = ?
	WHERE
	    ${dbprefix}_Baloons.IDStrip = ?
	ORDER BY
	    ${dbprefix}_Baloons.IDStrip, ${dbprefix}_Baloons.Location, ${dbprefix}_Baloons.IDBaloon;
    ");
    $q->execute(array($lang, $id));
    $arr['Baloons'] = $q->fetchAll(PDO::FETCH_ASSOC);
    $q->closeCursor();
    return $arr;
}

function strip_import($arr) {
    global $dbprefix;
    mytransaction_begin(); //TODO
    myupdate("REPLACE INTO ${dbprefix}_Titles (IDLanguage, IDStrip, Content, Publish, Discussione) VALUES (?, ?, ?, ?, ?);",
	array(
	    $arr['IDLanguage'],
	    (int) $arr['IDStrip'],
	    $arr['Title'],
	    $arr['PublishDate'],
	    $arr['ForumLink'],
	));
    foreach($arr['Baloons'] as $row) {
	myupdate("REPLACE INTO ${dbprefix}_Baloons (IDBaloon, IDStrip, Location, Shape, IDCharacter, ColorBG, ColorFG) VALUES (?, ?, ?, ?, ?, ?, ?);",
	    array(
		$row['IDBaloon'],
		$arr['IDStrip'],
		$row['Location'],
		$row['Shape'],
		$row['IDCharacter'],
		$row['ColorBG'],
		$row['ColorFG'],
	    ));
	myupdate("DELETE FROM ${dbprefix}_Texts WHERE ${dbprefix}_Texts.IDBaloon = ? AND ${dbprefix}_Texts.IDLanguage = ?;",
	    array($row['IDBaloon'], $arr['IDLanguage']));
	if (strlen($row['Content']) > 0)
	    myupdate("INSERT INTO ${dbprefix}_Texts (IDLanguage, IDBaloon, CenterX, CenterY, Content, Translator) VALUES (?, ?, ?, ?, ?, ?);",
		array(
		    $arr['IDLanguage'],
		    $row['IDBaloon'],
		    $row['CenterX'],
		    $row['CenterY'],
		    $row['Content'],
		    $row['Translator'],
		));
    }
    myupdate("UPDATE ${dbprefix}_Titles SET Version = ? WHERE IDLanguage = ? AND IDStrip = ?;",
	array($arr['Version'], $arr['IDLanguage'], $arr['IDStrip']));
    mytransaction_commit();
}
?>
